#include "theBiasPlanet/coreUtilities/constantsGroups/BaseEnumerableConstantsGroup.hpp"

namespace theBiasPlanet {
	namespace coreUtilities {
		namespace constantsGroups {
			template <typename T> BaseEnumerableConstantsGroup <T>::BaseEnumerableConstantsGroup (NavigableLinkedMap <string, T> const & a_nameToValueMap) : i_nameToValueMap (a_nameToValueMap) {
			}
			
			template <typename T> set <string> BaseEnumerableConstantsGroup <T>::getNames () const {
				set <string> l_names;
				for (typename NavigableLinkedMap <string, T>::value_type const & l_nameToValueMapEntry: i_nameToValueMap) {
					l_names.insert (l_nameToValueMapEntry.first);
				}
				return l_names;
			}
			
			template <typename T> list <T> BaseEnumerableConstantsGroup <T>::getValues () const {
				list <T> l_values;
				for (typename NavigableLinkedMap <string, T>::value_type const & l_nameToValueMapEntry: i_nameToValueMap) {
					l_values.push_back (l_nameToValueMapEntry.second);
				}
				return l_values;
			}
		}
	}
}

