#include "theBiasPlanet/filesConverter/programs/FilesConverterConsoleProgram.hpp"
#include <ctime>
#include <iomanip>
#include <iostream>
#include <exception>
#include <fstream>
#include <locale>
#include <optional>
#include <string>
#include <thread>
#include <com/sun/star/beans/NamedValue.hpp>
#include <com/sun/star/uno/Any.hxx>
#include <com/sun/star/uno/Exception.hpp>
#include "theBiasPlanet/coreUtilities/collectionsHandling/ListsFactory.hpp"
#include "theBiasPlanet/coreUtilities/constantsGroups/GeneralConstantsConstantsGroup.hpp"
#include "theBiasPlanet/coreUtilities/cryptographyHandling/Hasher.hpp"
#include "theBiasPlanet/coreUtilities/messagingHandling/Publisher.hpp"
#include "theBiasPlanet/coreUtilities/performanceMeasuringHandling/PerformanceMeasurer.hpp"
#include "theBiasPlanet/coreUtilities/stringsHandling/StringHandler.hpp"
#include "theBiasPlanet/coreUtilities/stringsHandling/StringTokenizer.hpp"
#include "theBiasPlanet/unoUtilities/connection/UnoConnection.hpp"
#include "theBiasPlanet/unoUtilities/connectionsHandling/UnoConnectionConnector.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoCharactersEncodingCodesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoDocumentStoringFilterNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoDocumentStoringEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoObjectsContextPropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoPdfExportingPropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/cryptographyHandling/MicrosoftPasswordsHasher.hpp"
#include "theBiasPlanet/unoUtilities/displayElements/UnoDesktop.hpp"
#include "theBiasPlanet/unoUtilities/documentsHandling/UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor.hpp"
#include "theBiasPlanet/unoUtilities/nameValuePairsHandling/UnoNameValuePairsHandler.hpp"
#include "theBiasPlanet/unoUtilities/pointers/UnoObjectPointer.hpp"
#include "theBiasPlanet/unoUtilities/processesHandling/UnoProcessEnvironment.hpp"
#include "theBiasPlanet/unoUtilities/propertiesHandling/UnoPropertiesHandler.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"
#include "theBiasPlanet/unoUtilities/unoDataHandling/UnoDatumConverter.hpp"
#include "theBiasPlanet/unoUtilities/unoObjectsContext/RemoteUnoObjectsContext.hpp"

using namespace ::std;
using namespace ::com::sun::star::container;
using namespace ::com::sun::star::uno;
using namespace ::theBiasPlanet::coreUtilities::collectionsHandling;
using namespace ::theBiasPlanet::coreUtilities::constantsGroups;
using namespace ::theBiasPlanet::coreUtilities::cryptographyHandling;
using namespace ::theBiasPlanet::coreUtilities::messagingHandling;
using namespace ::theBiasPlanet::coreUtilities::performanceMeasuringHandling;
using namespace ::theBiasPlanet::coreUtilities::stringsHandling;
using namespace ::theBiasPlanet::unoUtilities::connectionsHandling;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups::propertyNamesSets;
using namespace ::theBiasPlanet::unoUtilities::cryptographyHandling;
using namespace ::theBiasPlanet::unoUtilities::documentsHandling;
using namespace ::theBiasPlanet::unoUtilities::documentsHandling;
using namespace ::theBiasPlanet::unoUtilities::nameValuePairsHandling;
using namespace ::theBiasPlanet::unoUtilities::pointers;
using namespace ::theBiasPlanet::unoUtilities::processesHandling;
using namespace ::theBiasPlanet::unoUtilities::propertiesHandling;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;
using namespace ::theBiasPlanet::unoUtilities::unoDataHandling;
using namespace ::theBiasPlanet::unoUtilities::unoObjectsContext;

namespace theBiasPlanet {
	namespace filesConverter {
		namespace programs {
			void FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::initialize () {
				i_currentKey = nullopt;
				i_disabled = false;
				i_originalFileUrl = nullopt;
				i_targetFileUrl = nullopt;
				i_fileStoringFilterName = nullopt;
				i_openingPassword = nullopt;
				i_title = nullopt;
				i_encryptingPassword = nullopt;
				i_editingPassword = nullopt;
				i_certificateIssuerName = nullopt;
				i_certificatePassword = nullopt;
				i_signatureTimeStampAuthorityUrl = nullopt;
				i_unoDocumentTailorNames = nullopt;
				i_allSpreadSheetsAreExported = false;
				i_targetFileNamingRule = 0;
				i_csvItemsDelimiterCharacterCode = ',';
				i_csvTextItemQuotationCharacterCode = '\"';
				i_csvCharactersEncodingCode = UnoCharactersEncodingCodesConstantsGroup::c_utf8; // 76: UTF-8, 65535: UCS-2, 65534: UCS-4, 11: US-ASCII, 69: EUC_JP, 64: SHIFT_JIS
				i_csvAllTextItemsAreQuoted = false;
				i_csvContentsAreExportedAsShown = false;
				i_csvFormulaeThemselvesAreExported = false;
				i_hiddenSpreadSheetsAreExported = false;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getDisabled () {
				return i_disabled;
			}
			
			optional <string> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getOriginalFileUrl () {
				return i_originalFileUrl;
			}
			
			optional <string> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getTargetFileUrl () {
				return i_targetFileUrl;
			}
			
			optional <string> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getFileStoringFilterName () {
				return i_fileStoringFilterName;
			}
			
			optional <string> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getOpeningPassword () {
				return i_openingPassword;
			}
			
			optional <string> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getTitle () {
				return i_title;
			}
			
			optional <string> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getEncryptingPassword () {
				return i_encryptingPassword;
			}
			
			optional <string> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getEditingPassword () {
				return i_editingPassword;
			}
			
			optional <string> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getCertificateIssuerName () {
				return i_certificateIssuerName;
			}
			
			optional <string> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getCertificatePassword () {
				return i_certificatePassword;
			}
			
			optional <string> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getSignatureTimeStampAuthorityUrl () {
				return i_signatureTimeStampAuthorityUrl;
			}
			
			optional <list <string>> FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getUnoDocumentTailorNames () {
				return i_unoDocumentTailorNames;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getAllSpreadSheetsAreExported () {
				return i_allSpreadSheetsAreExported;
			}
			
			int FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getTargetFileNamingRule () {
				return i_targetFileNamingRule;
			}
			
			int FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getCsvItemsDelimiterCharacterCode () {
				return i_csvItemsDelimiterCharacterCode;
			}
			
			int FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getCsvTextItemQuotationCharacterCode () {
				return i_csvTextItemQuotationCharacterCode;
			}
			
			int FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getCsvCharactersEncodingCode () {
				return i_csvCharactersEncodingCode;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getCsvAllTextItemsAreQuoted () {
				return i_csvAllTextItemsAreQuoted;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getCsvContentsAreExportedAsShown () {
				return i_csvContentsAreExportedAsShown;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getCsvFormulaeThemselvesAreExported () {
				return i_csvFormulaeThemselvesAreExported;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::getHiddenSpreadSheetsAreExported () {
				return i_hiddenSpreadSheetsAreExported;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onBooleanFound (bool const & a_value) {
				if (*i_currentKey == c_disabledKey) {
					 i_disabled = a_value;
					 if (i_disabled) {
						 return false;
					 }
				}
				else if (*i_currentKey == c_allSpreadSheetsAreExportedKey) {
					i_allSpreadSheetsAreExported = a_value;
				}
				else if (*i_currentKey == c_csvAllTextItemsAreQuotedKey) {
					i_csvAllTextItemsAreQuoted = a_value;
				}
				else if (*i_currentKey == c_csvContentsAreExportedAsShownKey) {
					i_csvContentsAreExportedAsShown = a_value;
				}
				else if (*i_currentKey == c_csvFormulaeThemselvesAreExportedKey) {
					i_csvFormulaeThemselvesAreExported = a_value;
				}
				else if (*i_currentKey == c_hiddenSpreadSheetsAreExportedKey) {
					i_hiddenSpreadSheetsAreExported = a_value;
				}
				i_currentKey = nullopt;
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onIntegerFound (int const & a_value) {
				if (*i_currentKey == c_targetFileNamingRuleKey) {
					i_targetFileNamingRule = a_value;
				}
				else if (*i_currentKey == c_csvItemsDelimiterCharacterCodeKey) {
					i_csvItemsDelimiterCharacterCode = a_value;
				}
				else if (*i_currentKey == c_csvTextItemQuotationCharacterCodeKey) {
					i_csvTextItemQuotationCharacterCode = a_value;
				}
				else if (*i_currentKey == c_csvCharactersEncodingCodeKey) {
					i_csvCharactersEncodingCode = a_value;
				}
				i_currentKey = nullopt;
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onDoubleFound (double const & a_value) {
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onLocalDateAndTimeFound (time_point <system_clock> const & a_value) {
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onLocalDateFound (time_point <system_clock> const & a_value) {
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onLocalTimeFound (time_point <system_clock> const & a_value) {
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onBytesArrayFound (StringPipe * a_reader) {
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onStringFound (StringPipe * a_reader) {
				string l_string = a_reader->readWholeString ();
				if (! (i_currentKey.has_value ())) {
					i_currentKey = l_string;
					if (i_currentKey == c_unoDocumentTailorNamesKey) {
						i_unoDocumentTailorNames = list <string> ();
					}
				}
				else {
					if (*i_currentKey == c_originalFileUrlKey) {
						i_originalFileUrl = StringHandler::effectuateEnvironmentVariables (l_string);
					}
					else if (*i_currentKey == c_targetFileUrlKey) {
						i_targetFileUrl = StringHandler::effectuateEnvironmentVariables (l_string);
					}
					else if (*i_currentKey == c_fileStoringFilterNameKey) {
						i_fileStoringFilterName = l_string;
					}
					else if (*i_currentKey == c_openingPasswordKey) {
						i_openingPassword = l_string;
					}
					else if (*i_currentKey == c_titleKey) {
						i_title = l_string;
					}
					else if (*i_currentKey == c_encryptingPasswordKey) {
						i_encryptingPassword = l_string;
					}
					else if (*i_currentKey == c_editingPasswordKey) {
						i_editingPassword = l_string;
					}
					else if (*i_currentKey == c_certificateIssuerNameKey) {
						i_certificateIssuerName = l_string;
					}
					else if (*i_currentKey == c_certificatePasswordKey) {
						i_certificatePassword = l_string;
					}
					else if (*i_currentKey == c_signatureTimeStampAuthorityUrlKey) {
						i_signatureTimeStampAuthorityUrl = l_string;
					}
					else if (*i_currentKey == c_unoDocumentTailorNamesKey) {
						(*i_unoDocumentTailorNames).push_back (l_string);
					}
					if (*i_currentKey != c_unoDocumentTailorNamesKey) {
						i_currentKey = nullopt;
					}
				}
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onArrayStarted () {
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onArrayEnded () {
				if (*i_currentKey == c_unoDocumentTailorNamesKey) {
					i_currentKey = nullopt;
				}
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onDictionaryStarted () {
				return true;
			}
			
			bool FilesConverterConsoleProgram::FileConversionOrderExtendedJsonDatumParseEventsHandler::onDictionaryEnded () {
				return true;
			}
			
			int FilesConverterConsoleProgram::main (int const & a_argumentsNumber, char const * const a_argumentsArray []) {
				Publisher::setLoggingLevel (1);
				int l_resultStatus = -1;
				try {
					if (a_argumentsNumber < 3) {
						throw runtime_error ("The arguments have to be these.\nThe argument 1: the server URL like 'socket,host=localhost,port=2002,tcpNoDelay=1;urp;StarOffice.ComponentContext'\nThe argument 2: the path of the conversion orders JSON file\n");
					}
					string l_unoServerUrl = string (a_argumentsArray [1]);
					UnoProcessEnvironment l_localUnoProcessEnvironment = UnoProcessEnvironment (StringHandler::getDateAndTimeString (time (nullptr)));
					UnoConnectionConnector l_unoConnectionConnector = UnoConnectionConnector (l_localUnoProcessEnvironment.getLocalObjectsContext ());
					UnoObjectPointer <UnoConnection> l_unoConnection (l_unoConnectionConnector.connect (l_unoServerUrl , nullopt));
					if (l_unoConnection.isEmpty ()) {
						throw runtime_error (StringHandler::format (string ("%s"), string ("The UNO connection could not be established.")));
					}
					Publisher::logNormalInformation (string ("### A connection has been established."));
					UnoObjectPointer <RemoteUnoObjectsContext> l_remoteUnoObjectsContext (l_unoConnection->getRemoteUnoObjectsContext ());
					UnoObjectPointer <UnoDesktop> * l_unoDesktop = (UnoObjectPointer <UnoDesktop> *) l_remoteUnoObjectsContext->getLocalPropertyValue (UnoObjectsContextPropertyNamesSet::c_unoDesktopSingleton_string);
					FilesConverter l_filesConverter (*l_unoDesktop);
					map <string const, UnoDocumentTailor *> l_unoDocumentTailorNameToUnoDocumentTailorMap { {string ("UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor_1"), new UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor (l_remoteUnoObjectsContext, 1)}};
					list <thread *> l_conversionsThreads;
					PerformanceMeasurer::setStartTime ();
					for (int l_conversionOrdersFilePathIndex = GeneralConstantsConstantsGroup::c_iterationStartNumber; l_conversionOrdersFilePathIndex < a_argumentsNumber - c_conversionsOrderFilePathsStartIndexInArgumentsArray; l_conversionOrdersFilePathIndex ++) {
						string l_conversionOrdersFilePath = string (a_argumentsArray [c_conversionsOrderFilePathsStartIndexInArgumentsArray + l_conversionOrdersFilePathIndex]);
						thread * l_conversionsThread = new thread ( [l_conversionOrdersFilePath, &l_filesConverter, &l_unoDocumentTailorNameToUnoDocumentTailorMap] () -> void {
							try {
								executeConversionOrders (l_conversionOrdersFilePath, &l_filesConverter, l_unoDocumentTailorNameToUnoDocumentTailorMap);
							}
							catch (exception const & l_exception) {
								Publisher::logErrorInformation (l_exception);
							}
						});
						l_conversionsThreads.push_back (l_conversionsThread);
					}
					for (thread * l_conversionsThread: l_conversionsThreads) {
						l_conversionsThread->join ();
						delete l_conversionsThread;
					}
					for (pair <string const, UnoDocumentTailor *> const & l_unoDocumentTailorNameToUnoDocumentTailorMapEntry: l_unoDocumentTailorNameToUnoDocumentTailorMap) {
						delete l_unoDocumentTailorNameToUnoDocumentTailorMapEntry.second;
					}
					cout << StringHandler::format ("### The elapsed time is %s ns.", StringHandler::getThousandsSeparatedLongString (PerformanceMeasurer::getElapseTimeInNanoSeconds ())) <<  endl << flush;
					l_unoConnection->disconnect ();
					l_resultStatus = 0;
				}
				catch (Exception & l_exception) {
					Publisher::logErrorInformation (UnoExtendedStringHandler::getString (l_exception.Message));
					exit (l_resultStatus);
				}
				catch (exception & l_exception) {
					Publisher::logErrorInformation (l_exception);
					exit (l_resultStatus);
				}
				exit (l_resultStatus);
			}
			
			void FilesConverterConsoleProgram::executeConversionOrders (string const & a_conversionOrdersFilePath, FilesConverter * a_filesConverter, map <string const, UnoDocumentTailor *> const & a_unoDocumentTailorNameToUnoDocumentTailorMap) {
				int l_conversionOrderIndex = GeneralConstantsConstantsGroup::c_iterationStartNumber;
				string l_conversionOrder ("");
				string l_failedConversionOrderIndices ("");
				bool l_conversionHasSucceeded = false;
				ifstream l_conversionOrdersFile;
				l_conversionOrdersFile.open (a_conversionOrdersFilePath, ios::in);
				int l_jsonDictionaryLineStartIndex = GeneralConstantsConstantsGroup::c_unspecifiedInteger;
				int l_jsonDictionaryLineEndIndex = GeneralConstantsConstantsGroup::c_unspecifiedInteger;
				ExtendedJsonDatumParser l_conversionOrderExtendedJsonDatumParser;
				FileConversionOrderExtendedJsonDatumParseEventsHandler l_fileConversionOrderExtendedJsonDatumParseEventsHandler;
				while (true) {
					l_conversionHasSucceeded = false;
					if (! getline (l_conversionOrdersFile, l_conversionOrder)) {
						break;
					}
					else {
						if (l_conversionOrder [GeneralConstantsConstantsGroup::c_iterationStartNumber] == GeneralConstantsConstantsGroup::c_jsonArrayOpener || l_conversionOrder [GeneralConstantsConstantsGroup::c_iterationStartNumber] == GeneralConstantsConstantsGroup::c_jsonArrayCloser) {
							l_conversionOrderIndex ++;
							continue;
						}
						l_jsonDictionaryLineStartIndex = l_conversionOrder.find (GeneralConstantsConstantsGroup::c_jsonDictionaryOpener);
						l_jsonDictionaryLineEndIndex = l_conversionOrder.rfind (GeneralConstantsConstantsGroup::c_jsonDictionaryCloser);
						if (l_jsonDictionaryLineStartIndex < GeneralConstantsConstantsGroup::c_iterationStartNumber || l_jsonDictionaryLineEndIndex < GeneralConstantsConstantsGroup::c_iterationStartNumber) {
							Publisher::logErrorInformation (StringHandler::format ("The conversion order of the index, '%d', doesn't contain any valid JSON dictionary.'\n", l_conversionOrderIndex));
						}
						else {
							l_conversionOrder = l_conversionOrder.substr (l_jsonDictionaryLineStartIndex, l_jsonDictionaryLineEndIndex + 1);
							try {
								l_conversionHasSucceeded = executeConversionOrder (l_conversionOrder, a_filesConverter, a_unoDocumentTailorNameToUnoDocumentTailorMap, &l_conversionOrderExtendedJsonDatumParser, &l_fileConversionOrderExtendedJsonDatumParseEventsHandler);
							}
							catch (exception & l_exception) {
								Publisher::logErrorInformation (StringHandler::format ("The order of the index, '%d' has failed: %s.", l_conversionOrderIndex, string (l_exception.what ())));
							}
							if (!l_conversionHasSucceeded) {
								if (l_failedConversionOrderIndices.length () == 0) {
								}
								else {
									l_failedConversionOrderIndices.append (",");
								}
								l_failedConversionOrderIndices.append (StringHandler::format ("%d", l_conversionOrderIndex));
							}
						}
					}
					l_conversionOrderIndex ++;
				}
				l_conversionOrdersFile.close ();
				cout << StringHandler::format ("### The failed conversion order indices of '%s' are {%s}.", a_conversionOrdersFilePath, l_failedConversionOrderIndices) <<  endl << flush;
			}
			
			bool FilesConverterConsoleProgram::executeConversionOrder (string const & a_conversionOrder, FilesConverter * a_filesConverter, map <string const, UnoDocumentTailor *> const & a_unoDocumentTailorNameToUnoDocumentTailorMap, ExtendedJsonDatumParser * const a_conversionOrderExtendedJsonDatumParser, FileConversionOrderExtendedJsonDatumParseEventsHandler * const a_fileConversionOrderExtendedJsonDatumParseEventsHandler) {
				bool l_conversionHasSucceeded (false);
				bool l_overwrites (true);
				optional <string> l_originalFileUrl (nullopt);
				optional <string> l_targetFileUrl (nullopt);
				optional <string> l_fileStoringFilterName (nullopt);
				optional <string> l_encryptingPassword (nullopt);
				list <string> l_encryptionDatumNames (ListsFactory::createList <string> (string ("OOXPassword"), string ("CryptoType")));
				list <Any> l_encryptionDatumValues;
				Sequence <NamedValue> l_encryptionDatumSequence;
				optional <string> l_editingPassword (nullopt);
				list <string> l_editingPasswordInformationPropertyNames (ListsFactory::createList <string> (string ("algorithm-name"), string ("salt"), string ("iteration-count"), string ("hash")));
				int const l_saltLength (16);
				unsigned char l_salt [l_saltLength];
				Hasher::createSalt (l_salt, l_saltLength);
				int const l_numberOfIterationForHashing (100000);
				int const l_editingPasswordHashLength (16);
				unsigned char l_editingPasswordHash [l_editingPasswordHashLength];
				list <Any> l_editingPasswordInformationPropertyValues;
				Sequence <PropertyValue> l_editingPasswordInformationPropertiesSequence;
				long l_editingPasswordMicrosoftHash (GeneralConstantsConstantsGroup::c_unspecifiedInteger);
				Any l_editingPasswordInformation;
				optional <string> l_certificateIssuerName (nullopt);
				optional <string> l_signatureTimeStampAuthorityUrl (nullopt);
				/*
				optional <list <string>> l_documentStoringFilterDataInPropertiesSequencePropertyNames;
				optional <list <Any>> l_documentStoringFilterDataInPropertiesSequencePropertyValues;
				*/
				list <string> l_documentStoringFilterDataInPropertiesSequencePropertyNames;
				list <Any> l_documentStoringFilterDataInPropertiesSequencePropertyValues;
				optional <string> l_documentStoringFilterDataInStringValue (nullopt);
				Sequence <PropertyValue> l_documentStoringPropertiesSequence;
				optional <list <UnoDocumentTailor *>> l_unoDocumentTailors (nullopt);
				istringstream l_conversionOrderStream (a_conversionOrder);
				a_conversionOrderExtendedJsonDatumParser->parse (&l_conversionOrderStream, a_fileConversionOrderExtendedJsonDatumParseEventsHandler);
				l_originalFileUrl = a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getOriginalFileUrl ();
				l_targetFileUrl = a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getTargetFileUrl ();
				l_fileStoringFilterName = a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getFileStoringFilterName ();
				if (a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getDisabled ()) {
					return true;
				}
				if (! (l_originalFileUrl.has_value ())) {
					throw runtime_error ("The original file URL specification is missing.");
				}
				else if (! (l_targetFileUrl.has_value ())) {
					throw runtime_error ("The target file URL specification is missing.");
				}
				else if (! (l_fileStoringFilterName.has_value ())) {
					throw runtime_error ("The filter name specification is missing.");
				}
				else {
					optional <list <string>> l_unoDocumentTailorNames = a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getUnoDocumentTailorNames ();
					if (l_unoDocumentTailorNames.has_value ()) {
						try {
							l_unoDocumentTailors = list <UnoDocumentTailor *> ();
							for (string l_unoDocumentTailorName: *l_unoDocumentTailorNames) {
								(*l_unoDocumentTailors).push_back (a_unoDocumentTailorNameToUnoDocumentTailorMap.at (l_unoDocumentTailorName));
							}
						}
						catch (exception & l_exception) {
						}
					}
					if (!(*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toCsvFileFilterName)) {
						l_encryptingPassword = a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getEncryptingPassword ();
						if (l_encryptingPassword.has_value ()) {
							if (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftWord2007XmlFileFilterName || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftExcel2007XmlFileFilterName || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftPowerPoint2007XmlFileFilterName) {
								l_encryptionDatumValues = ListsFactory::createList <Any> (UnoDatumConverter::convertToUnoAnyDatum (l_encryptingPassword), UnoDatumConverter::convertToUnoAnyDatum (string ("Standard")));
								l_encryptionDatumSequence = UnoNameValuePairsHandler::buildNameValuePairsSequence (l_encryptionDatumNames, l_encryptionDatumValues);
								l_encryptingPassword = nullopt;
							}
							else if (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForTextDocuments || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForSpreadSheetsDocuments || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForPresentationDocuments) {
								/*
								if (! (l_documentStoringFilterDataInPropertiesSequencePropertyNames.has_value ())) {
									l_documentStoringFilterDataInPropertiesSequencePropertyNames = ListsFactory::createList <string> ();
									l_documentStoringFilterDataInPropertiesSequencePropertyValues = ListsFactory::createList <Any> ();
								}
								(*l_documentStoringFilterDataInPropertiesSequencePropertyNames).push_back (UnoPdfExportingPropertyNamesSet::c_fileIsEncrypted_boolean);
								(*l_documentStoringFilterDataInPropertiesSequencePropertyNames).push_back (UnoPdfExportingPropertyNamesSet::c_openingPassword_string);
								(*l_documentStoringFilterDataInPropertiesSequencePropertyValues).push_back (UnoDatumConverter::convertToUnoAnyDatum (true));
								(*l_documentStoringFilterDataInPropertiesSequencePropertyValues).push_back (UnoDatumConverter::convertToUnoAnyDatum (*l_encryptingPassword));
								*/
								l_documentStoringFilterDataInPropertiesSequencePropertyNames.push_back (UnoPdfExportingPropertyNamesSet::c_fileIsEncrypted_boolean);
								l_documentStoringFilterDataInPropertiesSequencePropertyNames.push_back (UnoPdfExportingPropertyNamesSet::c_openingPassword_string);
								l_documentStoringFilterDataInPropertiesSequencePropertyValues.push_back (UnoDatumConverter::convertToUnoAnyDatum (true));
								l_documentStoringFilterDataInPropertiesSequencePropertyValues.push_back (UnoDatumConverter::convertToUnoAnyDatum (*l_encryptingPassword));
								l_encryptingPassword = nullopt;
							}
						}
						l_editingPassword = a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getEditingPassword ();
						if (l_editingPassword.has_value ()) {
							if (! (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftWord2007XmlFileFilterName) && ! (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftWord97FileFilterName) && ! (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftExcel2007XmlFileFilterName) && ! (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftExcel97FileFilterName) && ! (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftPowerPoint2007XmlFileFilterName) && ! (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftPowerPoint97FileFilterName)) {
								Hasher::hashInPbkdf2 (l_editingPasswordHash, *l_editingPassword, l_salt, l_saltLength, l_numberOfIterationForHashing, l_editingPasswordHashLength);
								l_editingPasswordInformationPropertyValues = ListsFactory::createList <Any> (UnoDatumConverter::convertToUnoAnyDatum (string ("PBKDF2")), UnoDatumConverter::convertToUnoAnyDatum <unsigned char, sal_Int8> (l_salt, l_saltLength), UnoDatumConverter::convertToUnoAnyDatum ( (long) l_numberOfIterationForHashing), UnoDatumConverter::convertToUnoAnyDatum <unsigned char, sal_Int8> (l_editingPasswordHash, l_editingPasswordHashLength));
								l_editingPasswordInformationPropertiesSequence = UnoPropertiesHandler::buildPropertiesSequence (l_editingPasswordInformationPropertyNames, l_editingPasswordInformationPropertyValues);
								l_editingPasswordInformation = UnoDatumConverter::convertToUnoAnyDatum <Sequence <PropertyValue>> (l_editingPasswordInformationPropertiesSequence);
							}
							else {
								if (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftWord2007XmlFileFilterName || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftWord97FileFilterName || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftExcel2007XmlFileFilterName || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftPowerPoint2007XmlFileFilterName) {
									l_editingPasswordMicrosoftHash = MicrosoftPasswordsHasher::hashIn32bits (*l_editingPassword);
								}
								else {
									l_editingPasswordMicrosoftHash = MicrosoftPasswordsHasher::hashIn16bits (*l_editingPassword);
								}
								l_editingPasswordInformation = UnoDatumConverter::convertToUnoAnyDatum <long> (l_editingPasswordMicrosoftHash);
							}
						}
						l_certificateIssuerName = a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getCertificateIssuerName ();
						if (l_certificateIssuerName.has_value ()) {
							if (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForTextDocuments || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForSpreadSheetsDocuments || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForPresentationDocuments) {
								/*
								if (! (l_documentStoringFilterDataInPropertiesSequencePropertyNames.has_value ())) {
									l_documentStoringFilterDataInPropertiesSequencePropertyNames = ListsFactory::createList <string> ();
									l_documentStoringFilterDataInPropertiesSequencePropertyValues = ListsFactory::createList <Any> ();
								}
								(*l_documentStoringFilterDataInPropertiesSequencePropertyNames).push_back (UnoPdfExportingPropertyNamesSet::c_fileIsSigned_boolean);
								(*l_documentStoringFilterDataInPropertiesSequencePropertyNames).push_back (UnoPdfExportingPropertyNamesSet::c_signatureCertificate_com_sun_star_security_XCertificate);
								(*l_documentStoringFilterDataInPropertiesSequencePropertyNames).push_back (UnoPdfExportingPropertyNamesSet::c_signatureCertificatePassword_string);
								(*l_documentStoringFilterDataInPropertiesSequencePropertyValues).push_back (UnoDatumConverter::convertToUnoAnyDatum (true));
								(*l_documentStoringFilterDataInPropertiesSequencePropertyValues).push_back (UnoDatumConverter::convertToUnoAnyDatum (a_filesConverter->getUnoObjectsContext ()->getNetworkSecurityServicesCertificate (*l_certificateIssuerName, nullopt).getPointerInReference ()));
								(*l_documentStoringFilterDataInPropertiesSequencePropertyValues).push_back (UnoDatumConverter::convertToUnoAnyDatum (a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getCertificatePassword ()));
								*/
								l_documentStoringFilterDataInPropertiesSequencePropertyNames.push_back (UnoPdfExportingPropertyNamesSet::c_fileIsSigned_boolean);
								l_documentStoringFilterDataInPropertiesSequencePropertyNames.push_back (UnoPdfExportingPropertyNamesSet::c_signatureCertificate_com_sun_star_security_XCertificate);
								l_documentStoringFilterDataInPropertiesSequencePropertyNames.push_back (UnoPdfExportingPropertyNamesSet::c_signatureCertificatePassword_string);
								l_documentStoringFilterDataInPropertiesSequencePropertyValues.push_back (UnoDatumConverter::convertToUnoAnyDatum (true));
								l_documentStoringFilterDataInPropertiesSequencePropertyValues.push_back (UnoDatumConverter::convertToUnoAnyDatum (a_filesConverter->getRemoteUnoObjectsContext ()->getNetworkSecurityServicesCertificate (*l_certificateIssuerName, nullopt).getPointerInReference ()));
								l_documentStoringFilterDataInPropertiesSequencePropertyValues.push_back (UnoDatumConverter::convertToUnoAnyDatum (a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getCertificatePassword ()));
							}
						}
						l_signatureTimeStampAuthorityUrl = a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getSignatureTimeStampAuthorityUrl ();
						if (l_signatureTimeStampAuthorityUrl.has_value ()) {
							if (*l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForTextDocuments || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForSpreadSheetsDocuments || *l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForPresentationDocuments) {
								/*
								if (! (l_documentStoringFilterDataInPropertiesSequencePropertyNames.has_value ())) {
									l_documentStoringFilterDataInPropertiesSequencePropertyNames = ListsFactory::createList <string> ();
									l_documentStoringFilterDataInPropertiesSequencePropertyValues = ListsFactory::createList <Any> ();
								}
								(*l_documentStoringFilterDataInPropertiesSequencePropertyNames).push_back (UnoPdfExportingPropertyNamesSet::c_signatureTimeStampAuthorityUrl_string);
								(*l_documentStoringFilterDataInPropertiesSequencePropertyValues).push_back (UnoDatumConverter::convertToUnoAnyDatum (*l_signatureTimeStampAuthorityUrl));
								*/
								l_documentStoringFilterDataInPropertiesSequencePropertyNames.push_back (UnoPdfExportingPropertyNamesSet::c_signatureTimeStampAuthorityUrl_string);
								l_documentStoringFilterDataInPropertiesSequencePropertyValues.push_back (UnoDatumConverter::convertToUnoAnyDatum (*l_signatureTimeStampAuthorityUrl));
							}
						}
						list <string> l_documentStoringPropertyNames (ListsFactory::createList <string> (
							UnoDocumentStoringEnumerablePropertyNamesSet::c_filterName_string,
							UnoDocumentStoringEnumerablePropertyNamesSet::c_filterData_any,
							UnoDocumentStoringEnumerablePropertyNamesSet::c_filterData_string,
							UnoDocumentStoringEnumerablePropertyNamesSet::c_title_string,
							UnoDocumentStoringEnumerablePropertyNamesSet::c_encryptionData_NamedValuesSequence,
							UnoDocumentStoringEnumerablePropertyNamesSet::c_password_string,
							UnoDocumentStoringEnumerablePropertyNamesSet::c_editingPasswordInformation_any,
							UnoDocumentStoringEnumerablePropertyNamesSet::c_overwrites_boolean
						));
						list <Any> l_documentStoringPropertyValues = ListsFactory::createList <Any> (
							UnoDatumConverter::convertToUnoAnyDatum (l_fileStoringFilterName),
							//UnoDatumConverter::convertToUnoAnyDatum (UnoPropertiesHandler::buildPropertiesSequence (*l_documentStoringFilterDataInPropertiesSequencePropertyNames, *l_documentStoringFilterDataInPropertiesSequencePropertyValues)),
							UnoDatumConverter::convertToUnoAnyDatum (UnoPropertiesHandler::buildPropertiesSequence (l_documentStoringFilterDataInPropertiesSequencePropertyNames, l_documentStoringFilterDataInPropertiesSequencePropertyValues)),
							UnoDatumConverter::convertToUnoAnyDatum (l_documentStoringFilterDataInStringValue),
							UnoDatumConverter::convertToUnoAnyDatum (a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getTitle ()),
							l_encryptionDatumSequence.getLength () > 0 ? UnoDatumConverter::convertToUnoAnyDatum (l_encryptionDatumSequence): Any (),
							UnoDatumConverter::convertToUnoAnyDatum (l_encryptingPassword),
							l_editingPasswordInformation,
							UnoDatumConverter::convertToUnoAnyDatum (l_overwrites)
						);
						l_documentStoringPropertiesSequence = UnoPropertiesHandler::buildPropertiesSequence (l_documentStoringPropertyNames, l_documentStoringPropertyValues);
					}
					else {
						l_documentStoringPropertiesSequence = FilesConverter::createToCsvFileDocumentStoringPropertiesSequence (a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getCsvItemsDelimiterCharacterCode (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getCsvTextItemQuotationCharacterCode (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getCsvCharactersEncodingCode (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getCsvAllTextItemsAreQuoted (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getCsvContentsAreExportedAsShown (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getCsvFormulaeThemselvesAreExported ());
					}
					if (!(a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getAllSpreadSheetsAreExported ())) {
						l_conversionHasSucceeded = a_filesConverter->convertFile (*l_originalFileUrl, a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getOpeningPassword (), *l_targetFileUrl, l_documentStoringPropertiesSequence, l_unoDocumentTailors);
					}
					else {
						l_conversionHasSucceeded = a_filesConverter->convertSpreadSheetsDocumentFileToCsvFiles (*l_originalFileUrl, a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getOpeningPassword (), *l_targetFileUrl, l_documentStoringPropertiesSequence, l_unoDocumentTailors, a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getTargetFileNamingRule (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler->getHiddenSpreadSheetsAreExported ());
					}
				}
				return l_conversionHasSucceeded;
			}
		}
	}
}

