#ifndef __theBiasPlanet_filesConverter_programs_FilesConverterConsoleProgram_hpp__
#define __theBiasPlanet_filesConverter_programs_FilesConverterConsoleProgram_hpp__

	#include <list>
	#include <map>
	#include <optional>
	#include <string>
	#include "theBiasPlanet/coreUtilities/jsonDataHandling/ExtendedJsonDatumParseEventsHandler.hpp"
	#include "theBiasPlanet/coreUtilities/jsonDataHandling/ExtendedJsonDatumParser.hpp"
	#include "theBiasPlanet/unoUtilities/constantsGroups/UnoCharactersEncodingCodesConstantsGroup.hpp"
	#include "theBiasPlanet/unoUtilities/documentsHandling/UnoDocumentTailor.hpp"
	#include "theBiasPlanet/unoUtilities/fileConversionsHandling/FilesConverter.hpp"
	
	using namespace ::std;
	using namespace ::theBiasPlanet::coreUtilities::jsonDataHandling;
	using namespace ::theBiasPlanet::unoUtilities::constantsGroups;
	using namespace ::theBiasPlanet::unoUtilities::documentsHandling;
	using namespace ::theBiasPlanet::unoUtilities::fileConversionsHandling;
	
	namespace theBiasPlanet {
		namespace filesConverter {
			namespace programs {
				class FilesConverterConsoleProgram {
					private:
						static int const c_conversionsOrderFilePathsStartIndexInArgumentsArray;
						class FileConversionOrderExtendedJsonDatumParseEventsHandler :public ExtendedJsonDatumParseEventsHandler {
							private:
								static string const c_disabledKey;
								static string const c_originalFileUrlKey;
								static string const c_targetFileUrlKey;
								static string const c_fileStoringFilterNameKey;
								static string const c_openingPasswordKey;
								static string const c_titleKey;
								static string const c_encryptingPasswordKey;
								static string const c_editingPasswordKey;
								static string const c_certificateIssuerNameKey;
								static string const c_certificatePasswordKey;
								static string const c_signatureTimeStampAuthorityUrlKey;
								static string const c_unoDocumentTailorNamesKey;
								static string const c_allSpreadSheetsAreExportedKey;
								static string const c_targetFileNamingRuleKey;
								static string const c_csvItemsDelimiterCharacterCodeKey;
								static string const c_csvTextItemQuotationCharacterCodeKey;
								static string const c_csvCharactersEncodingCodeKey;
								static string const c_csvAllTextItemsAreQuotedKey;
								static string const c_csvContentsAreExportedAsShownKey;
								static string const c_csvFormulaeThemselvesAreExportedKey;
								static string const c_hiddenSpreadSheetsAreExportedKey;
								optional <string> i_currentKey;
								bool i_disabled;
								optional <string> i_originalFileUrl;
								optional <string> i_targetFileUrl;
								optional <string> i_fileStoringFilterName;
								optional <string> i_openingPassword;
								optional <string> i_title;
								optional <string> i_encryptingPassword;
								optional <string> i_editingPassword;
								optional <string> i_certificateIssuerName;
								optional <string> i_certificatePassword;
								optional <string> i_signatureTimeStampAuthorityUrl;
								optional <list <string>> i_unoDocumentTailorNames;
								bool i_allSpreadSheetsAreExported;
								int i_targetFileNamingRule;
								int i_csvItemsDelimiterCharacterCode;
								int i_csvTextItemQuotationCharacterCode;
								int i_csvCharactersEncodingCode;
								bool i_csvAllTextItemsAreQuoted;
								bool i_csvContentsAreExportedAsShown;
								bool i_csvFormulaeThemselvesAreExported;
								bool i_hiddenSpreadSheetsAreExported;
							public:
								virtual void initialize () override;
								virtual bool getDisabled ();
								virtual optional <string> getOriginalFileUrl ();
								virtual optional <string> getTargetFileUrl ();
								virtual optional <string> getFileStoringFilterName ();
								virtual optional <string> getOpeningPassword ();
								virtual optional <string> getTitle ();
								virtual optional <string> getEncryptingPassword ();
								virtual optional <string> getEditingPassword ();
								virtual optional <string> getCertificateIssuerName ();
								virtual optional <string> getCertificatePassword ();
								virtual optional <string> getSignatureTimeStampAuthorityUrl ();
								virtual optional <list <string>> getUnoDocumentTailorNames ();
								virtual bool getAllSpreadSheetsAreExported ();
								virtual int getTargetFileNamingRule ();
								virtual int getCsvItemsDelimiterCharacterCode ();
								virtual int getCsvTextItemQuotationCharacterCode ();
								virtual int getCsvCharactersEncodingCode ();
								virtual bool getCsvAllTextItemsAreQuoted ();
								virtual bool getCsvContentsAreExportedAsShown ();
								virtual bool getCsvFormulaeThemselvesAreExported ();
								virtual bool getHiddenSpreadSheetsAreExported ();
								virtual bool onBooleanFound (bool const & a_value) override;
								virtual bool onIntegerFound (int const & a_value) override;
								virtual bool onDoubleFound (double const & a_value) override;
								virtual bool onLocalDateAndTimeFound (time_point <system_clock> const & a_value) override;
								virtual bool onLocalDateFound (time_point <system_clock> const & a_value) override;
								virtual bool onLocalTimeFound (time_point <system_clock> const & a_value) override;
								virtual bool onBytesArrayFound (StringPipe * a_reader) override;
								virtual bool onStringFound (StringPipe * a_reader) override;
								virtual bool onArrayStarted () override;
								virtual bool onArrayEnded () override;
								virtual bool onDictionaryStarted () override;
								virtual bool onDictionaryEnded () override;
						};
					public:
						static int main (int const & a_argumentsNumber, char const * const a_argumentsArray []);
						static void executeConversionOrders (string const & a_conversionOrdersFilePath, FilesConverter * a_filesConverter, map <string const, UnoDocumentTailor *> const & a_unoDocumentTailorNameToUnoDocumentTailorMap);
						static bool executeConversionOrder (string const & a_conversionOrder, FilesConverter * a_filesConverter, map <string const, UnoDocumentTailor *> const & a_unoDocumentTailorNameToUnoDocumentTailorMap, ExtendedJsonDatumParser * const a_conversionOrderExtendedJsonDatumParser, FileConversionOrderExtendedJsonDatumParseEventsHandler * const a_fileConversionOrderExtendedJsonDatumParseEventsHandler);
				};
			}
		}
	}
#endif

