from typing import cast
from typing import Dict
from typing import List
from typing import Optional
from typing import TextIO
from datetime import date
from datetime import datetime
from datetime import time
from io import StringIO
import sys
from threading import Condition
from threading import Thread
import uno
from com.sun.star.beans import PropertyValue
from com.sun.star.beans import NamedValue
from uno import Any
from  theBiasPlanet.coreUtilities.constantsGroups.GeneralConstantsConstantsGroup import GeneralConstantsConstantsGroup
from theBiasPlanet.coreUtilities.collectionsHandling.ListsFactory import ListsFactory
from theBiasPlanet.coreUtilities.collectionsHandling.MapsFactory import MapsFactory
from theBiasPlanet.coreUtilities.cryptographyHandling.Hasher import Hasher
from theBiasPlanet.coreUtilities.datumConversionsHandling.DatumConverter import DatumConverter
from theBiasPlanet.coreUtilities.jsonDataHandling.ExtendedJsonDatumParseEventsHandler import ExtendedJsonDatumParseEventsHandler
from theBiasPlanet.coreUtilities.jsonDataHandling.ExtendedJsonDatumParser import ExtendedJsonDatumParser
from theBiasPlanet.coreUtilities.messagingHandling.Publisher import Publisher
from theBiasPlanet.coreUtilities.performanceMeasuringHandling.PerformanceMeasurer import PerformanceMeasurer
from theBiasPlanet.coreUtilities.pipes.StringPipe import StringPipe
from theBiasPlanet.coreUtilities.stringsHandling.StringHandler import StringHandler
from theBiasPlanet.coreUtilities.stringsHandling.StringTokenizer import StringTokenizer
from theBiasPlanet.unoUtilities.connection.UnoConnection import UnoConnection
from theBiasPlanet.unoUtilities.connectionsHandling.UnoConnectionConnector import UnoConnectionConnector
from theBiasPlanet.unoUtilities.constantsGroups.UnoCharactersEncodingCodesConstantsGroup import UnoCharactersEncodingCodesConstantsGroup
from theBiasPlanet.unoUtilities.constantsGroups.UnoDatumTypeNamesConstantsGroup import UnoDatumTypeNamesConstantsGroup
from theBiasPlanet.unoUtilities.constantsGroups.UnoDocumentStoringFilterNamesConstantsGroup import UnoDocumentStoringFilterNamesConstantsGroup
from theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets.UnoDocumentStoringEnumerablePropertyNamesSet import UnoDocumentStoringEnumerablePropertyNamesSet
from theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets.UnoPdfExportingPropertyNamesSet import UnoPdfExportingPropertyNamesSet
from theBiasPlanet.unoUtilities.cryptographyHandling.MicrosoftPasswordsHasher import MicrosoftPasswordsHasher
from theBiasPlanet.unoUtilities.displayElements.UnoDesktop import UnoDesktop
from theBiasPlanet.unoUtilities.documentsHandling.UnoDocumentTailor import UnoDocumentTailor
from theBiasPlanet.unoUtilities.documentsHandling.UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor import UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor
from theBiasPlanet.unoUtilities.fileConversionsHandling.FilesConverter import FilesConverter
from theBiasPlanet.unoUtilities.nameValuePairsHandling.UnoNameValuePairsHandler import UnoNameValuePairsHandler
from theBiasPlanet.unoUtilities.processesHandling.UnoProcessEnvironment import UnoProcessEnvironment
from theBiasPlanet.unoUtilities.propertiesHandling.UnoPropertiesHandler import UnoPropertiesHandler
from theBiasPlanet.unoUtilities.unoDataHandling.UnoDatumConverter import UnoDatumConverter
from theBiasPlanet.unoUtilities.unoObjectsContexts.RemoteUnoObjectsContextInterface import RemoteUnoObjectsContextInterface

class FilesConverterConsoleProgram:
	c_conversionsOrderFilePathsStartIndexInArgumentsArray: int = 2
	class FileConversionOrderExtendedJsonDatumParseEventsHandler (ExtendedJsonDatumParseEventsHandler):
		c_disabledKey: str = "Disabled"
		c_originalFileUrlKey: str = "OriginalFileUrl"
		c_targetFileUrlKey: str = "TargetFileUrl"
		c_fileStoringFilterNameKey: str = "FileStoringFilterName"
		c_openingPasswordKey: str = "OpeningPassword"
		c_titleKey: str = "Title"
		c_encryptingPasswordKey: str = "EncryptingPassword"
		c_editingPasswordKey: str = "EditingPassword"
		c_certificateIssuerNameKey: str = "CertificateIssuerName"
		c_certificatePasswordKey: str = "CertificatePassword"
		c_signatureTimeStampAuthorityUrlKey: str = "SignatureTimeStampAuthorityUrl"
		c_unoDocumentTailorNamesKey: str = "DocumentTailorNames"
		c_allSpreadSheetsAreExportedKey: str = "AllSpreadSheetsAreExported"
		c_targetFileNamingRuleKey: str = "TargetFileNamingRule"
		c_csvItemsDelimiterCharacterCodeKey: str = "CsvItemsDelimiterCharacterCode"
		c_csvTextItemQuotationCharacterCodeKey: str = "CsvTextItemQuotationCharacterCode"
		c_csvCharactersEncodingCodeKey: str = "CsvCharactersEncodingCode"
		c_csvAllTextItemsAreQuotedKey: str = "CsvAllTextItemsAreQuoted"
		c_csvContentsAreExportedAsShownKey: str = "CsvContentsAreExportedAsShown"
		c_csvFormulaeThemselvesAreExportedKey: str = "CsvFormulaeThemselvesAreExported"
		c_hiddenSpreadSheetsAreExportedKey: str = "HiddenSpreadSheetsAreExported"
		
		def __init__ (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler"):
			a_this.i_currentKey: Optional [str]
			a_this.i_disabled:bool
			a_this.i_originalFileUrl: Optional [str]
			a_this.i_targetFileUrl: Optional [str]
			a_this.i_fileStoringFilterName: Optional [str]
			a_this.i_openingPassword: Optional [str]
			a_this.i_title: Optional [str]
			a_this.i_encryptingPassword: Optional [str]
			a_this.i_editingPassword: Optional [str]
			a_this.i_certificateIssuerName: Optional [str]
			a_this.i_certificatePassword: Optional [str]
			a_this.i_signatureTimeStampAuthorityUrl: Optional [str]
			a_this.i_unoDocumentTailorNames: Optional [List [str]]
			a_this.i_allSpreadSheetsAreExported: bool
			a_this.i_targetFileNamingRule: int
			a_this.i_csvItemsDelimiterCharacterCode: int
			a_this.i_csvTextItemQuotationCharacterCode: int
			a_this.i_csvCharactersEncodingCode: int
			a_this.i_csvAllTextItemsAreQuoted: bool
			a_this.i_csvContentsAreExportedAsShown: bool
			a_this.i_csvFormulaeThemselvesAreExported: bool
			a_this.i_hiddenSpreadSheetsAreExported: bool
		
		def initialize (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> None:
			a_this.i_currentKey = None
			a_this.i_disabled = False
			a_this.i_originalFileUrl = None
			a_this.i_targetFileUrl = None
			a_this.i_fileStoringFilterName = None
			a_this.i_openingPassword = None
			a_this.i_title = None
			a_this.i_encryptingPassword = None
			a_this.i_editingPassword = None
			a_this.i_certificateIssuerName = None
			a_this.i_certificatePassword = None
			a_this.i_signatureTimeStampAuthorityUrl = None
			a_this.i_unoDocumentTailorNames = None
			a_this.i_allSpreadSheetsAreExported = False
			a_this.i_targetFileNamingRule = 0
			a_this.i_csvItemsDelimiterCharacterCode = ord (",")
			a_this.i_csvTextItemQuotationCharacterCode = ord ("\"")
			a_this.i_csvCharactersEncodingCode = UnoCharactersEncodingCodesConstantsGroup.c_utf8 # 76: UTF-8, 65535: UCS-2, 65534: UCS-4, 11: US-ASCII, 69: EUC_JP, 64: SHIFT_JIS
			a_this.i_csvAllTextItemsAreQuoted = False
			a_this.i_csvContentsAreExportedAsShown = False
			a_this.i_csvFormulaeThemselvesAreExported = False
			a_this.i_hiddenSpreadSheetsAreExported = False
		
		def getDisabled (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
			return a_this.i_disabled
		
		def getOriginalFileUrl (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> str:
			return a_this.i_originalFileUrl
		
		def getTargetFileUrl (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> str:
			return a_this.i_targetFileUrl
		
		def getFileStoringFilterName (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> str:
			return a_this.i_fileStoringFilterName
		
		def getOpeningPassword (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> str:
			return a_this.i_openingPassword
		
		def getTitle (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> str:
			return a_this.i_title
		
		def getEncryptingPassword (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> str:
			return a_this.i_encryptingPassword
		
		def getEditingPassword (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") ->str:
			return a_this.i_editingPassword
		
		def getCertificateIssuerName (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> str:
			return a_this.i_certificateIssuerName
		
		def getCertificatePassword (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> str:
			return a_this.i_certificatePassword
		
		def getSignatureTimeStampAuthorityUrl (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> str:
			return a_this.i_signatureTimeStampAuthorityUrl
		
		def getUnoDocumentTailorNames (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> Optional [List [str]]:
			return a_this.i_unoDocumentTailorNames
		
		def getAllSpreadSheetsAreExported (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
			return a_this.i_allSpreadSheetsAreExported
		
		def getTargetFileNamingRule (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> int:
			return a_this.i_targetFileNamingRule
		
		def getCsvItemsDelimiterCharacterCode (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> int:
			return a_this.i_csvItemsDelimiterCharacterCode
		
		def getCsvTextItemQuotationCharacterCode (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> int:
			return a_this.i_csvTextItemQuotationCharacterCode
		
		def getCsvCharactersEncodingCode (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> int:
			return a_this.i_csvCharactersEncodingCode
		
		def getCsvAllTextItemsAreQuoted (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
			return a_this.i_csvAllTextItemsAreQuoted
		
		def getCsvContentsAreExportedAsShown (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
			return a_this.i_csvContentsAreExportedAsShown
		
		def getCsvFormulaeThemselvesAreExported (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
			return a_this.i_csvFormulaeThemselvesAreExported
		
		def getHiddenSpreadSheetsAreExported (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
			return a_this.i_hiddenSpreadSheetsAreExported
		
		def onBooleanFound (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler", a_value: bool) -> bool:
			if a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_disabledKey:
				 a_this.i_disabled = a_value
				 if a_this.i_disabled:
					 return False
			elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_allSpreadSheetsAreExportedKey:
				a_this.i_allSpreadSheetsAreExported = a_value
			elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_csvAllTextItemsAreQuotedKey:
				a_this.i_csvAllTextItemsAreQuoted = a_value
			elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_csvContentsAreExportedAsShownKey:
				a_this.i_csvContentsAreExportedAsShown = a_value
			elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_csvFormulaeThemselvesAreExportedKey:
				a_this.i_csvFormulaeThemselvesAreExported = a_value
			elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_hiddenSpreadSheetsAreExportedKey:
				a_this.i_hiddenSpreadSheetsAreExported = a_value
			a_this.i_currentKey = None
			return True
		
		def onIntegerFound (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler", a_value: int) -> bool:
			if a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_targetFileNamingRuleKey:
				a_this.i_targetFileNamingRule = a_value
			elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_csvItemsDelimiterCharacterCodeKey:
				a_this.i_csvItemsDelimiterCharacterCode = a_value
			elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_csvTextItemQuotationCharacterCodeKey:
				a_this.i_csvTextItemQuotationCharacterCode = a_value
			elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_csvCharactersEncodingCodeKey:
				a_this.i_csvCharactersEncodingCode = a_value
			a_this.i_currentKey = None
			return True
		
		def onDoubleFound (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler", a_value: float) -> bool:
			return True
		
		def onLocalDateAndTimeFound (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler", a_value: datetime) -> bool:
			return True
		
		def onLocalDateFound (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler", a_value: date) -> bool:
			return True
		
		def onLocalTimeFound (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler", a_value: time) -> bool:
			return True
		
		def onBytesArrayFound (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler", a_reader: "StringPipe") -> bool:
			return True
		
		def onStringFound (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler", a_reader: "StringPipe") -> bool:
			l_string: str = a_reader.readWholeString ()
			if a_this.i_currentKey is None:
				a_this.i_currentKey = l_string
				if a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_unoDocumentTailorNamesKey:
					a_this.i_unoDocumentTailorNames = []
			else:
				if a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_originalFileUrlKey:
					a_this.i_originalFileUrl = StringHandler.effectuateEnvironmentVariables (l_string)
				elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_targetFileUrlKey:
					a_this.i_targetFileUrl = StringHandler.effectuateEnvironmentVariables (l_string);
				elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_fileStoringFilterNameKey:
					a_this.i_fileStoringFilterName = l_string
				elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_openingPasswordKey:
					a_this.i_openingPassword = l_string
				elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_titleKey:
					a_this.i_title = l_string
				elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_encryptingPasswordKey:
					a_this.i_encryptingPassword = l_string
				elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_editingPasswordKey:
					a_this.i_editingPassword = l_string
				elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_certificateIssuerNameKey:
					a_this.i_certificateIssuerName = l_string
				elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_certificatePasswordKey:
					a_this.i_certificatePassword = l_string
				elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_signatureTimeStampAuthorityUrlKey:
					a_this.i_signatureTimeStampAuthorityUrl = l_string
				elif a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_unoDocumentTailorNamesKey:
					a_this.i_unoDocumentTailorName = l_string
				if a_this.i_currentKey != FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_unoDocumentTailorNamesKey:
					a_this.i_currentKey = None
			return True
		
		def onArrayStarted (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
			return True
		
		def onArrayEnded (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
			if a_this.i_currentKey == FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler.c_unoDocumentTailorNamesKey:
				a_this.i_currentKey = None
			return True
		
		def onDictionaryStarted (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
			return True
		
		def onDictionaryEnded (a_this: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
			return True
	
	@staticmethod
	def main (a_arguments: List [str]) -> None:
		l_resultStatus: int = -1
		try:
			if (len (a_arguments) < 3):
				raise Exception ("The arguments have to be these.\nThe argument 1: the server URL like 'socket,host=localhost,port=2002,tcpNoDelay=1;urp;StarOffice.ComponentContext'\nThe argument 2: the path of the conversion orders JSON file\n")
			l_unoServerUrl: str = a_arguments [1]
			l_localUnoProcessEnvironment: "UnoProcessEnvironment" = UnoProcessEnvironment (str (datetime.now ()), None)
			l_unoConnectionConnector: "UnoConnectionConnector" = UnoConnectionConnector (l_localUnoProcessEnvironment.getLocalObjectsContext ())
			l_unoConnection: "UnoConnection" = l_unoConnectionConnector.connect (l_unoServerUrl, None)
			if l_unoConnection is None:
				raise Exception ("{0:s}".format ("The UNO connection could not be established."))
			Publisher.logNormalInformation ("### A connection has been established.")
			l_remoteUnoObjectsContext: "Optional [RemoteUnoObjectsContextInterface]" = l_unoConnection.getRemoteUnoObjectsContext ()
			l_filesConverter: "FilesConverter" = FilesConverter (UnoDesktop.getInstance (l_remoteUnoObjectsContext))
			l_unoDocumentTailorNameToUnoDocumentTailorMap: Dict [str, "UnoDocumentTailor"] = MapsFactory.createOrderedMap (str, UnoDocumentTailor, "UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor_1", UnoSpreadSheetsDocumentMoveSpecifiedSheetTo1stPositionTailor (l_remoteUnoObjectsContext, 1))
			l_conversionsThreads: List [Thread] = []
			PerformanceMeasurer.setStartTime ()
			l_conversionOrdersFilePathIndex: int = GeneralConstantsConstantsGroup.c_iterationStartNumber
			def l_conversionsThreadFunction (a_conversionOrdersFilePath: str) -> None:
				try:
					FilesConverterConsoleProgram.executeConversionOrders (a_conversionOrdersFilePath, l_filesConverter, l_unoDocumentTailorNameToUnoDocumentTailorMap)
				except (Exception) as l_exception:
					Publisher.logErrorInformation (l_exception)
			l_conversionsThread: Thread
			for l_conversionOrdersFilePathIndex in range (GeneralConstantsConstantsGroup.c_iterationStartNumber, len (a_arguments) - FilesConverterConsoleProgram.c_conversionsOrderFilePathsStartIndexInArgumentsArray):
				l_conversionOrdersFilePath: str = a_arguments [FilesConverterConsoleProgram.c_conversionsOrderFilePathsStartIndexInArgumentsArray + l_conversionOrdersFilePathIndex]
				l_conversionsThread = Thread (target = l_conversionsThreadFunction, args = (l_conversionOrdersFilePath, ))
				l_conversionsThreads.append (l_conversionsThread)
				l_conversionsThread.start ()
			for l_conversionsThread in l_conversionsThreads:
				l_conversionsThread.join ()
			sys.stdout.write ("### The elapsed time is {0:,d} ns.\n".format (PerformanceMeasurer.getElapseTimeInNanoSeconds ()))
			l_unoConnection.disconnect ()
			l_resultStatus = 0
		except (Exception) as l_exception:
			Publisher.logErrorInformation (l_exception)
			sys.exit (l_resultStatus)
		sys.exit (l_resultStatus)
	
	@staticmethod
	def executeConversionOrders (a_conversionOrdersFilePath: str, a_filesConverter: "FilesConverter", a_unoDocumentTailorNameToUnoDocumentTailorMap: Dict [str, "UnoDocumentTailor"]) -> None:
		l_conversionOrderIndex: int = GeneralConstantsConstantsGroup.c_iterationStartNumber
		l_conversionOrder: Optional [str] = None
		l_failedConversionOrderIndicesStringBuilder: List [str] = ListsFactory.createList (str)
		l_conversionHasSucceeded: bool = False
		l_jsonDictionaryLineStartIndex: int = GeneralConstantsConstantsGroup.c_unspecifiedInteger
		l_jsonDictionaryLineEndIndex: int = GeneralConstantsConstantsGroup.c_unspecifiedInteger
		l_conversionOrdersFileReader: TextIO = open (a_conversionOrdersFilePath, "r")
		l_conversionOrderExtendedJsonDatumParser: "ExtendedJsonDatumParser " = ExtendedJsonDatumParser ()
		l_fileConversionOrderExtendedJsonDatumParseEventsHandler: "FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler" = FilesConverterConsoleProgram.FileConversionOrderExtendedJsonDatumParseEventsHandler ()
		while True:
			l_conversionHasSucceeded = False
			l_conversionOrder = l_conversionOrdersFileReader.readline ()
			if l_conversionOrder == "":
				break
			else:
				if l_conversionOrder.startswith (GeneralConstantsConstantsGroup.c_jsonArrayOpener) or l_conversionOrder.startswith (GeneralConstantsConstantsGroup.c_jsonArrayCloser):
					l_conversionOrderIndex = l_conversionOrderIndex + 1
					continue;
				l_jsonDictionaryLineStartIndex = l_conversionOrder.index (GeneralConstantsConstantsGroup.c_jsonDictionaryOpener)
				l_jsonDictionaryLineEndIndex = l_conversionOrder.rindex (GeneralConstantsConstantsGroup.c_jsonDictionaryCloser)
				if l_jsonDictionaryLineStartIndex < GeneralConstantsConstantsGroup.c_iterationStartNumber or l_jsonDictionaryLineEndIndex < GeneralConstantsConstantsGroup.c_iterationStartNumber:
					Publisher.logErrorInformation ("The conversion order of the index, '{0:d}', doesn't contain any valid JSON dictionary.'\n".format (l_conversionOrderIndex))
				else:
					l_conversionOrder = l_conversionOrder [l_jsonDictionaryLineStartIndex: l_jsonDictionaryLineEndIndex + 1]
					try:
						l_conversionHasSucceeded = FilesConverterConsoleProgram.executeConversionOrder (l_conversionOrder, a_filesConverter, a_unoDocumentTailorNameToUnoDocumentTailorMap, l_conversionOrderExtendedJsonDatumParser, l_fileConversionOrderExtendedJsonDatumParseEventsHandler)
					except (Exception) as l_exception:
						Publisher.logErrorInformation ("The order of the index, '{0:d}' has failed: {1:s}.".format ( l_conversionOrderIndex, str (l_exception)))
					if not l_conversionHasSucceeded:
						if len (l_failedConversionOrderIndicesStringBuilder) == 0:
							None
						else:
		   			 		l_failedConversionOrderIndicesStringBuilder.append (",")
						l_failedConversionOrderIndicesStringBuilder.append ("{0:d}".format (l_conversionOrderIndex))
			l_conversionOrderIndex = l_conversionOrderIndex + 1
		l_conversionOrdersFileReader.close ()
		sys.stdout.write ("### The failed conversion order indices of '{0:s}' are {{{1:s}}}.\n".format (a_conversionOrdersFilePath, "".join (l_failedConversionOrderIndicesStringBuilder)))
	
	@staticmethod
	def executeConversionOrder (a_conversionOrder: str, a_filesConverter: "FilesConverter", a_unoDocumentTailorNameToUnoDocumentTailorMap: Dict [str, "UnoDocumentTailor"], a_conversionOrderExtendedJsonDatumParser: "ExtendedJsonDatumParser", a_fileConversionOrderExtendedJsonDatumParseEventsHandler: "FileConversionOrderExtendedJsonDatumParseEventsHandler") -> bool:
		l_conversionHasSucceeded: bool = False
		l_overwrites: bool = True
		l_originalFileUrl: Optional [str] = None
		l_targetFileUrl: Optional [str] = None
		l_fileStoringFilterName: Optional [str] = None
		l_encryptingPassword: Optional [str] = None
		l_encryptionDatumNames: List [str] = ListsFactory.createList (str, "OOXPassword", "CryptoType")
		l_encryptionDatumValues: Optional [List [object]] = None
		l_encryptionDatum: Optional [List [NamedValue]] = None
		l_editingPassword: Optional [str] = None
		l_editingPasswordInformationPropertyNames: List [str]  = ListsFactory.createList (str, "algorithm-name", "salt", "iteration-count", "hash")
		l_saltLength: int = 16
		l_salt: bytes = Hasher.createSalt (l_saltLength)
		l_numberOfIterationForHashing: int = 100000
		l_editingPasswordHashLength: int = 16
		l_editingPasswordHash: Optional [bytes] = None
		l_editingPasswordInformationPropertyValues: Optional [List [object]] = None
		l_editingPasswordInformationProperties: Optional [List [PropertyValue]] = None
		l_editingPasswordMicrosoftHash: int = GeneralConstantsConstantsGroup.c_unspecifiedInteger;
		l_editingPasswordInformation: Optional [Any] = None
		l_certificateIssuerName: Optional [str] = None
		l_signatureTimeStampAuthorityUrl: Optional [str] = None
		l_documentStoringFilterDataInPropertiesPropertyNames: List [str] = []
		l_documentStoringFilterDataInPropertiesPropertyValues: List [object]  = []
		l_documentStoringFilterDataInStringValue: Optional [str] = None
		l_documentStoringProperties: Optional [List [PropertyValue]] = None
		l_unoDocumentTailors: "Optional [List [UnoDocumentTailor]]" = None
		a_conversionOrderExtendedJsonDatumParser.parse (StringIO (a_conversionOrder), a_fileConversionOrderExtendedJsonDatumParseEventsHandler)
		l_originalFileUrl = a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getOriginalFileUrl ()
		l_targetFileUrl = a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getTargetFileUrl ()
		l_fileStoringFilterName = a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getFileStoringFilterName ()
		if a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getDisabled ():
			return True
		if l_originalFileUrl is None:
			raise Exception ("The original file URL specification is missing.")
		elif l_targetFileUrl is None:
			raise Exception ("The target file URL specification is missing.")
		elif l_fileStoringFilterName is None:
			raise Exception ("The filter name specification is missing.")
		else:
			l_unoDocumentTailorNames: List [str] = a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getUnoDocumentTailorNames ()
			if l_unoDocumentTailorNames is not None:
				try:
					for l_unoDocumentTailorName in l_unoDocumentTailorNames:
						l_unoDocumentTailors.append (a_unoDocumentTailorNameToUnoDocumentTailorMap [l_unoDocumentTailorName])
				except (Exception) as l_exception:
					None
			if not (l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toCsvFileFilterName):
				l_encryptingPassword = a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getEncryptingPassword ()
				if l_encryptingPassword is not None:
					if l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftWord2007XmlFileFilterName or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftExcel2007XmlFileFilterName or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftPowerPoint2007XmlFileFilterName:
						l_encryptionDatumValues = ListsFactory.createList (object, l_encryptingPassword, "Standard")
						l_encryptionDatum = UnoNameValuePairsHandler.buildNameValuePairs (l_encryptionDatumNames, l_encryptionDatumValues)
						l_encryptingPassword = None
					elif l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toPdfFileFilterNameForTextDocuments or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toPdfFileFilterNameForSpreadSheetsDocuments or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toPdfFileFilterNameForPresentationDocuments:
						if l_documentStoringFilterDataInPropertiesPropertyNames is None:
							l_documentStoringFilterDataInPropertiesPropertyNames = ListsFactory.createList (str)
							l_documentStoringFilterDataInPropertiesPropertyValues = ListsFactory.createList (object)
						l_documentStoringFilterDataInPropertiesPropertyNames.append (UnoPdfExportingPropertyNamesSet.c_fileIsEncrypted_boolean)
						l_documentStoringFilterDataInPropertiesPropertyNames.append (UnoPdfExportingPropertyNamesSet.c_openingPassword_string)
						l_documentStoringFilterDataInPropertiesPropertyValues.append (UnoDatumConverter.getAny (True, UnoDatumTypeNamesConstantsGroup.c_booleanTypeName))
						l_documentStoringFilterDataInPropertiesPropertyValues.append (UnoDatumConverter.getAny (l_encryptingPassword, UnoDatumTypeNamesConstantsGroup.c_stringTypeName))
						l_encryptingPassword = None
				l_editingPassword = a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getEditingPassword ()
				if l_editingPassword is not None:
					if not (l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftWord2007XmlFileFilterName) and not (l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftWord97FileFilterName) and not (l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftExcel2007XmlFileFilterName) and not (l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftExcel97FileFilterName) and not (l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftPowerPoint2007XmlFileFilterName) and not (l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftPowerPoint97FileFilterName):
						l_editingPasswordHash = Hasher.hashInPbkdf2 (l_editingPassword, l_salt, l_numberOfIterationForHashing, l_editingPasswordHashLength)
						l_editingPasswordInformationPropertyValues = ListsFactory.createList (object, "PBKDF2", UnoDatumConverter.getAny (ListsFactory.createSignedBytesList (l_salt), "{0:s}{1:s}".format (UnoDatumTypeNamesConstantsGroup.c_sequenceTypeNamePrefix, UnoDatumTypeNamesConstantsGroup.c_byteTypeName)), UnoDatumConverter.getAny (l_numberOfIterationForHashing, UnoDatumTypeNamesConstantsGroup.c_longTypeName), UnoDatumConverter.getAny (ListsFactory.createSignedBytesList (l_editingPasswordHash), "{0:s}{1:s}".format (UnoDatumTypeNamesConstantsGroup.c_sequenceTypeNamePrefix, UnoDatumTypeNamesConstantsGroup.c_byteTypeName)))
						l_editingPasswordInformationProperties = UnoPropertiesHandler.buildProperties (l_editingPasswordInformationPropertyNames, l_editingPasswordInformationPropertyValues)
						l_editingPasswordInformation = UnoDatumConverter.getAny (l_editingPasswordInformationProperties, "{0:s}{1:s}".format (UnoDatumTypeNamesConstantsGroup.c_sequenceTypeNamePrefix, "com.sun.star.beans.PropertyValue"))
					else:
						if l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftWord2007XmlFileFilterName or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftWord97FileFilterName or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftExcel2007XmlFileFilterName or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toMicrosoftPowerPoint2007XmlFileFilterName:
							l_editingPasswordMicrosoftHash = MicrosoftPasswordsHasher.hashIn32bits (l_editingPassword)
							l_editingPasswordInformation = UnoDatumConverter.getAny (DatumConverter.getSignedInteger (l_editingPasswordMicrosoftHash), "long")
						else:
							l_editingPasswordMicrosoftHash = MicrosoftPasswordsHasher.hashIn16bits (l_editingPassword)
							l_editingPasswordInformation = UnoDatumConverter.getAny (DatumConverter.getSignedShort (l_editingPasswordMicrosoftHash), "long")
				l_certificateIssuerName = a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getCertificateIssuerName ()
				if l_certificateIssuerName is not None:
					if l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toPdfFileFilterNameForTextDocuments or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toPdfFileFilterNameForSpreadSheetsDocuments or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toPdfFileFilterNameForPresentationDocuments:
						if l_documentStoringFilterDataInPropertiesPropertyNames is None:
							l_documentStoringFilterDataInPropertiesPropertyNames = ListsFactory.createList (str)
							l_documentStoringFilterDataInPropertiesPropertyValues = ListsFactory.createList (object)
						l_documentStoringFilterDataInPropertiesPropertyNames.append (UnoPdfExportingPropertyNamesSet.c_fileIsSigned_boolean)
						l_documentStoringFilterDataInPropertiesPropertyNames.append (UnoPdfExportingPropertyNamesSet.c_signatureCertificate_com_sun_star_security_XCertificate)
						l_documentStoringFilterDataInPropertiesPropertyNames.append (UnoPdfExportingPropertyNamesSet.c_signatureCertificatePassword_string)
						l_documentStoringFilterDataInPropertiesPropertyValues.append (UnoDatumConverter.getAny (True, UnoDatumTypeNamesConstantsGroup.c_booleanTypeName))
						l_documentStoringFilterDataInPropertiesPropertyValues.append (UnoDatumConverter.getAny (a_filesConverter.getRemoteUnoObjectsContext ().getNetworkSecurityServicesCertificate (l_certificateIssuerName, None), "com.sun.star.security.XCertificate"))
						l_documentStoringFilterDataInPropertiesPropertyValues.append (UnoDatumConverter.getAny (a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getCertificatePassword (), UnoDatumTypeNamesConstantsGroup.c_stringTypeName))
				l_signatureTimeStampAuthorityUrl = a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getSignatureTimeStampAuthorityUrl ()
				if l_signatureTimeStampAuthorityUrl is not None:
					if l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toPdfFileFilterNameForTextDocuments or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toPdfFileFilterNameForSpreadSheetsDocuments or l_fileStoringFilterName == UnoDocumentStoringFilterNamesConstantsGroup.c_toPdfFileFilterNameForPresentationDocuments:
						if l_documentStoringFilterDataInPropertiesPropertyNames is None:
							l_documentStoringFilterDataInPropertiesPropertyNames = ListsFactory.createList (str)
							l_documentStoringFilterDataInPropertiesPropertyValues = ListsFactory.createList (object)
						l_documentStoringFilterDataInPropertiesPropertyNames.append (UnoPdfExportingPropertyNamesSet.c_signatureTimeStampAuthorityUrl_string)
						l_documentStoringFilterDataInPropertiesPropertyValues.append (UnoDatumConverter.getAny (l_signatureTimeStampAuthorityUrl, UnoDatumTypeNamesConstantsGroup.c_stringTypeName))
				l_documentStoringPropertyNames: List [str] = ListsFactory.createList (
					str,
					UnoDocumentStoringEnumerablePropertyNamesSet.c_filterName_string,
					UnoDocumentStoringEnumerablePropertyNamesSet.c_filterData_any,
					UnoDocumentStoringEnumerablePropertyNamesSet.c_filterData_string,
					UnoDocumentStoringEnumerablePropertyNamesSet.c_title_string,
					UnoDocumentStoringEnumerablePropertyNamesSet.c_encryptionData_NamedValuesSequence,
					UnoDocumentStoringEnumerablePropertyNamesSet.c_password_string,
					UnoDocumentStoringEnumerablePropertyNamesSet.c_editingPasswordInformation_any,
					UnoDocumentStoringEnumerablePropertyNamesSet.c_overwrites_boolean
				)
				l_documentStoringPropertyValues: List [object] = ListsFactory.createList (
					object,
					UnoDatumConverter.getAny (l_fileStoringFilterName, UnoDatumTypeNamesConstantsGroup.c_stringTypeName),
					UnoDatumConverter.getAny (UnoPropertiesHandler.buildProperties (l_documentStoringFilterDataInPropertiesPropertyNames, l_documentStoringFilterDataInPropertiesPropertyValues), "{0:s}{1:s}".format (UnoDatumTypeNamesConstantsGroup.c_sequenceTypeNamePrefix, "com.sun.star.beans.PropertyValue")),
					UnoDatumConverter.getAny (l_documentStoringFilterDataInStringValue, UnoDatumTypeNamesConstantsGroup.c_stringTypeName),
					UnoDatumConverter.getAny (a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getTitle (), UnoDatumTypeNamesConstantsGroup.c_stringTypeName),
					UnoDatumConverter.getAny (l_encryptionDatum, "{0:s}{1:s}".format (UnoDatumTypeNamesConstantsGroup.c_sequenceTypeNamePrefix, "com.sun.star.beans.NamedValue")),
					UnoDatumConverter.getAny (l_encryptingPassword, UnoDatumTypeNamesConstantsGroup.c_stringTypeName),
					l_editingPasswordInformation,
					UnoDatumConverter.getAny (l_overwrites, UnoDatumTypeNamesConstantsGroup.c_booleanTypeName)
				)
				l_documentStoringProperties = UnoPropertiesHandler.buildProperties (l_documentStoringPropertyNames, l_documentStoringPropertyValues)
			else:
				l_documentStoringProperties = FilesConverter.createToCsvFileDocumentStoringProperties (a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getCsvItemsDelimiterCharacterCode (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getCsvTextItemQuotationCharacterCode (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getCsvCharactersEncodingCode (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getCsvAllTextItemsAreQuoted (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getCsvContentsAreExportedAsShown (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getCsvFormulaeThemselvesAreExported ())
			if not (a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getAllSpreadSheetsAreExported ()):
				l_conversionHasSucceeded = a_filesConverter.convertFile (l_originalFileUrl, a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getOpeningPassword (), l_targetFileUrl, l_documentStoringProperties, l_unoDocumentTailors)
			else:
				l_conversionHasSucceeded = a_filesConverter.convertSpreadSheetsDocumentFileToCsvFiles (l_originalFileUrl, a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getOpeningPassword (), l_targetFileUrl, l_documentStoringProperties, l_unoDocumentTailors, a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getTargetFileNamingRule (), a_fileConversionOrderExtendedJsonDatumParseEventsHandler.getHiddenSpreadSheetsAreExported ())
		return l_conversionHasSucceeded

if __name__ == "__main__":
	FilesConverterConsoleProgram.main (sys.argv)

