from typing import List
from com.sun.star.beans import PropertyValue
from com.sun.star.container import XEnumerationAccess
from com.sun.star.lang import XComponent
from com.sun.star.lang import XEventListener
from com.sun.star.uno import XComponentContext
from com.sun.star.uno import XInterface
from com.sun.star.util import URL as com_sun_star_util_URL

# The constants groups
class CommandGroup:
	None
 
class DispatchResultState:
	FAILURE: int
	SUCCESS: int
	DONTKNOW: int
 
class FrameSearchFlag:
	AUTO: int
	PARENT: int
	SELF: int
	CHILDREN: int
	CREATE: int
	SIBLINGS: int
	TASKS: int
	ALL: int
	GLOBAL: int
 
class InfobarType:
	None
 
class LayoutManagerEvents:
	None
 
class UntitledNumbersConst:
	None
 
class WindowArrange:
	None

# The others
class BorderWidths:
	None

class ControlCommand:
	None

class ControlEvent:
	None

class DispatchDescriptor:
	None

class DispatchInformation:
	None

class DispatchResultEvent:
	Source: XInterface 	
	State: int
	Result: object

class DispatchStatement:
	None

class DoubleInitializationException (BaseException):
	None

class FeatureStateEvent:
	Source: XInterface 	
	FeatureURL: com_sun_star_util_URL
	FeatureDescriptor: str
	IsEnabled: bool
	Requery: bool
	State: object

class FrameActionEvent:
	None

class IllegalArgumentIOException (BaseException):
	None

class TerminationVetoException (BaseException):
	None

class TitleChangedEvent:
	None

class UnknownModuleException (BaseException):
	None

class XAppDispatchProvider (XInterface):
	None

class XBorderResizeListener (XInterface):
	None

class XBrowseHistoryRegistry (XInterface):
	None

class XComponentLoader (XInterface):
	None

class XComponentRegistry (XInterface):
	None

class XConfigManager (XInterface):
	None

class XController (XInterface):
	None

class XController2 (XInterface):
	None

class XControllerBorder (XInterface):
	None

class XControlNotificationListener (XInterface):
	None

class XDesktop (XInterface):
	def terminate (a_this: "XDesktop") -> bool: ...
	def addTerminateListener (a_this: "XDesktop", Listener: "XTerminateListener") -> None: ...
	def removeTerminateListener (a_this: "XDesktop", Listener: "XTerminateListener") -> None: ...
	def getComponents (a_this: "XDesktop") -> "XEnumerationAccess": ...
	def getCurrentComponent (a_this: "XDesktop") -> "XComponent": ...
	def getCurrentFrame (a_this: "XDesktop") -> "XFrame": ...

class XDesktop2 (XInterface):
	None

class XDesktopTask (XInterface):
	None

class XDispatch (XInterface):
	None

class XDispatchHelper (XInterface):
	None

class XDispatchInformationProvider (XInterface):
	None

class XDispatchProvider (XInterface):
	def queryDispatch (a_this: "XDispatchProvider", URL: com_sun_star_util_URL, TargetFrameName: str, SearchFlags: int) -> XDispatch: ...
	def queryDispatches (a_this: "XDispatchProvider", Requests: List [DispatchDescriptor]) -> List [XDispatch]: ...

class XDispatchProviderInterception (XInterface):
	None

class XDispatchProviderInterceptor (XInterface):
	None

class XDispatchRecorder (XInterface):
	None

class XDispatchRecorderSupplier (XInterface):
	None

class XDispatchResultListener (XEventListener):
	def dispatchFinished (a_this: "XDispatchResultListener", Result: DispatchResultEvent) -> None: ...

class XDocumentTemplates (XInterface):
	None

class XExtendedFilterDetection (XInterface):
	None

class XFilterDetect (XInterface):
	None

class XFrame (XInterface):
	None

class XFrame2 (XInterface):
	None

class XFrameActionListener (XInterface):
	None

class XFrameLoader (XInterface):
	None

class XFrameLoaderQuery (XInterface):
	None

class XFrames (XInterface):
	None

class XFrameSetModel (XInterface):
	None

class XFramesSupplier (XInterface):
	None

class XGlobalEventBroadcaster (XInterface):
	None

class XInfobarProvider (XInterface):
	None

class XInterceptorInfo (XInterface):
	None

class XLayoutManager (XInterface):
	None

class XLayoutManager2 (XInterface):
	None

class XLayoutManagerEventBroadcaster (XInterface):
	None

class XLayoutManagerListener (XInterface):
	None

class XLoadable (XInterface):
	None

class XLoaderFactory (XInterface):
	None

class XLoadEventListener (XInterface):
	None

class XMenuBarAcceptor (XInterface):
	None

class XMenuBarMergingAcceptor (XInterface):
	None

class XModel (XInterface):
	None

class XModel2 (XInterface):
	None

class XModel3 (XInterface):
	None

class XModule (XInterface):
	None

class XModuleManager (XInterface):
	None

class XModuleManager2 (XInterface):
	None

class XNotifyingDispatch (XInterface):
	None

class XPopupMenuController (XInterface):
	None

class XRecordableDispatch (XInterface):
	None

class XSessionManagerClient (XInterface):
	None

class XSessionManagerListener (XInterface):
	None

class XSessionManagerListener2 (XInterface):
	None

class XStatusbarController (XInterface):
	None

class XStatusListener (XInterface):
	None

class XStorable (XInterface):
	def hasLocation (a_this: "XStorable") -> bool: ...
	def getLocation (a_this: "XStorable") -> str: ...
	def isReadonly (a_this: "XStorable") -> bool: ...
	def store (a_this: "XStorable") -> None: ...
	def storeAsURL (a_this: "XStorable", sURL: str, lArguments: List [PropertyValue]) -> None: ...
	def storeToURL (a_this: "XStorable", sURL: str, lArguments: List [PropertyValue]) -> None: ...

class XStorable2 (XStorable):
	def storeSelf (a_this: "XStorable2", lArguments: List [PropertyValue]) -> None: ...

class XSubToolbarController (XInterface):
	None

class XSynchronousDispatch (XInterface):
	def dispatchWithReturnValue (a_this: "XSynchronousDispatch", URL: com_sun_star_util_URL, Arguments: List [PropertyValue]) -> object: ...

class XSynchronousFrameLoader (XInterface):
	None

class XTask (XInterface):
	None

class XTasksSupplier (XInterface):
	None

class XTerminateListener (XInterface):
	None

class XTerminateListener2 (XInterface):
	None

class XTitle (XInterface):
	None

class XTitleChangeBroadcaster (XInterface):
	None

class XTitleChangeListener (XInterface):
	None

class XToolbarController (XInterface):
	None

class XToolbarControllerListener (XInterface):
	None

class XTransientDocumentsDocumentContentFactory (XInterface):
	None

class XTransientDocumentsDocumentContentIdentifierFactory (XInterface):
	None

class XUIControllerFactory (XInterface):
	None

class XUIControllerRegistration (XInterface):
	None

class XUntitledNumbers (XInterface):
	None

class XUrlList (XInterface):
	None

class XWindowArranger (XInterface):
	None

