#include "theBiasPlanet/unoUtilities/connectionsHandling/UnoConnectionConnector.hpp"
#include <ctime>
#include <iomanip>
#include <optional>
#include <sstream>
#include <com/sun/star/connection/NoConnectException.hpp>
#include <com/sun/star/connection/XConnection.hpp>
#include <com/sun/star/connection/XConnector.hpp>
#include <com/sun/star/uno/Reference.hxx>
#include "theBiasPlanet/coreUtilities/messagingHandling/Publisher.hpp"
#include "theBiasPlanet/coreUtilities/stringsHandling/StringHandler.hpp"
#include "theBiasPlanet/coreUtilities/stringsHandling/StringTokenizer.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoGeneralConstantsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoServiceNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::com::sun::star::connection;
using namespace ::theBiasPlanet::coreUtilities::messagingHandling;
using namespace ::theBiasPlanet::coreUtilities::stringsHandling;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace connectionsHandling {
			UnoConnectionConnector::UnoConnectionConnector (UnoObjectPointer <LocalUnoObjectsContext> & a_localUnoObjectsContext): UnoConnectionsFactory (a_localUnoObjectsContext) {
				initialize ();
			}
			
			UnoConnectionConnector::~UnoConnectionConnector () {
			}
			
			UnoObjectPointer <UnoConnection> UnoConnectionConnector::connect (string const & a_url, optional <list <UnoConnection::UnoConnectionEventsListener *>> const & a_eventsListeners) {
				StringTokenizer l_urlTokenizer (a_url, UnoGeneralConstantsConstantsGroup::c_connectionUrlDelimiter);
				UnoObjectPointer <XConnector> l_unoConnectionConnector (i_localUnoObjectsContext->getUnoServiceInstance (UnoServiceNamesConstantsGroup::c_com_sun_star_connection_Connector, nullopt), true);
				try {
					UnoObjectPointer <XConnection> l_unoConnection (l_unoConnectionConnector->connect (UnoExtendedStringHandler::getOustring (l_urlTokenizer.nextToken ().value ())));
					return setUpUnoConnection (l_unoConnection, &l_urlTokenizer, StringHandler::getDateAndTimeString (time (nullptr)), a_eventsListeners);
				}
				catch (NoConnectException l_exception) {
					Publisher::logErrorInformation (UnoExtendedStringHandler::getString (l_exception.Message));
					return nullptr;
				}
			}
		}
	}
}

