#include "theBiasPlanet/unoUtilities/displayElements/UnoFrame.hpp"
#include <com/sun/star/beans/PropertyValue.hpp>
#include <com/sun/star/frame/XDispatchProvider.hpp>
#include "theBiasPlanet/coreUtilities/collectionsHandling/ListsFactory.hpp"
#include "theBiasPlanet/coreUtilities/constantsGroups/GeneralConstantsConstantsGroup.hpp"
#include "theBiasPlanet/coreUtilities/messagingHandling/Publisher.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoSpecialFrameNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoDispatchesCommonArgumentEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/propertiesHandling/UnoPropertiesHandler.hpp"
#include <theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp>

using namespace ::com::sun::star::beans;
using namespace ::theBiasPlanet::coreUtilities::collectionsHandling;
using namespace ::theBiasPlanet::coreUtilities::constantsGroups;
using namespace ::theBiasPlanet::coreUtilities::messagingHandling;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups::propertyNamesSets;
using namespace ::theBiasPlanet::unoUtilities::propertiesHandling;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace displayElements {
			UnoFrame::UnoFrame (UnoObjectPointer <RemoteUnoObjectsContext> & a_remoteUnoObjectsContext, UnoObjectPointer <XFrame> const & a_underlyingUnoObject): ImplInheritanceHelper2 <UnoComponentBase, XDispatchResultListener, XStatusListener> (string ("::theBiasPlanet::unoUtilities::displayElements::UnoFrame")), i_remoteUnoObjectsContext (a_remoteUnoObjectsContext), i_underlyingUnoObject (a_underlyingUnoObject), i_containerWindow (i_underlyingUnoObject->getContainerWindow ()) {
			}
			
			UnoFrame::~UnoFrame () {
			}
			
			void SAL_CALL UnoFrame::dispatchFinished (DispatchResultEvent const & a_unoDispatchResultEvent) {
				i_dispatchResultAndRelatedInformation->setResult (a_unoDispatchResultEvent);
			}
			
			void SAL_CALL UnoFrame::statusChanged (FeatureStateEvent const & a_relatedInformationPieceEvent) {
				i_dispatchResultAndRelatedInformation->addRelatedInformationPiece (a_relatedInformationPieceEvent);
			}
			
			void SAL_CALL UnoFrame::disposing (::com::sun::star::lang::EventObject const & a_source) {
			}
			
			UnoObjectPointer <RemoteUnoObjectsContext> & UnoFrame::getRemoteUnoObjectsContext () {
				return i_remoteUnoObjectsContext;
			}
			
			UnoObjectPointer <XFrame> & UnoFrame::getUnderlyingUnoObject () {
				return i_underlyingUnoObject;
			}
			
			optional <::com::sun::star::awt::Rectangle> UnoFrame::getBoundary () {
				if (! (i_containerWindow.isEmpty ())) {
					::com::sun::star::awt::Rectangle l_boundary = i_containerWindow->getPosSize ();
					return l_boundary;
				}
				return nullopt;
			}
			
			UnoObjectPointer <XIndexAccess> UnoFrame::getChildFramesIterator () {
				UnoObjectPointer <XIndexAccess> l_unoFramesIterator (i_underlyingUnoObject.getPointerInReference <XFramesSupplier> (true)->getFrames ());
				return l_unoFramesIterator;
			}
			
			optional <list <UnoObjectPointer <UnoFrame>>> UnoFrame::getChildFrames () {
				optional <list <UnoObjectPointer <UnoFrame>>> l_childUnoFrames;
				UnoObjectPointer <XIndexAccess> l_unoFramesIterator (getChildFramesIterator ());
				int l_numberOfChildUnoFrames = l_unoFramesIterator->getCount ();
				if (l_numberOfChildUnoFrames > 0) {
					l_childUnoFrames = list <UnoObjectPointer <UnoFrame>> ();
					for (int l_unoFrameIndex = 0; l_unoFrameIndex < l_numberOfChildUnoFrames; l_unoFrameIndex ++) {
						try {
							l_childUnoFrames->push_back (UnoObjectPointer <UnoFrame> (new UnoFrame (i_remoteUnoObjectsContext, UnoObjectPointer <XFrame> ( (XFrame *) l_unoFramesIterator->getByIndex (l_unoFrameIndex).getValue ()))));
						}
						catch (exception const & l_exception) {
							Publisher::logErrorInformation (l_exception);
						}
					}
				}
				return l_childUnoFrames;
			}
			
			UnoObjectPointer <XNotifyingDispatch> UnoFrame::getUnoDispatcher (::com::sun::star::util::URL const & a_urlInURL) {
				return UnoObjectPointer <XNotifyingDispatch> (i_underlyingUnoObject.getPointerInReference <XDispatchProvider> (true)->queryDispatch (a_urlInURL, UnoExtendedStringHandler::getOustring (UnoSpecialFrameNamesConstantsGroup::c_self), GeneralConstantsConstantsGroup::c_unspecifiedInteger));
			}
			
			optional <UnoDispatchResultAndRelatedInformation> UnoFrame::fulfill (UnoDispatchSlotsConstantsGroup::BaseUnoDispatchSlot const & a_unoDispatchSlot, optional <list <Any>> const & a_unoDispatchArgumentValues) {
				unique_lock <recursive_mutex> l_lock (i_mutex);
				if (i_dispatchResultAndRelatedInformation != nullptr) {
					delete i_dispatchResultAndRelatedInformation;
					i_dispatchResultAndRelatedInformation = nullptr;
				}
				i_dispatchResultAndRelatedInformation = new UnoDispatchResultAndRelatedInformation ();
				Sequence <PropertyValue> l_unoDispatchArgumentPropertiesSequence;
				if (a_unoDispatchSlot.c_unoDispatchArgumentPropertyNamesSet.has_value ()) {
					 if (a_unoDispatchArgumentValues.has_value ()) {
						l_unoDispatchArgumentPropertiesSequence = UnoPropertiesHandler::buildPropertiesSequence (ListsFactory::createListExpandingItems <string> (UnoDispatchesCommonArgumentEnumerablePropertyNamesSet::c_instance.getValues (), a_unoDispatchSlot.c_unoDispatchArgumentPropertyNamesSet->getValues ()), ListsFactory::createListExpandingItems <Any> (Any (true), *a_unoDispatchArgumentValues));
					 }
					 else {
						l_unoDispatchArgumentPropertiesSequence = UnoPropertiesHandler::buildPropertiesSequence (UnoDispatchesCommonArgumentEnumerablePropertyNamesSet::c_instance.getValues (), ListsFactory::createList <Any> (Any (true)));
					 }
				}
				else {
					 if (a_unoDispatchArgumentValues.has_value ()) {
						list <Any>::const_iterator l_unoDispatchArgumentValuesIterator = a_unoDispatchArgumentValues->begin ();
						l_unoDispatchArgumentPropertiesSequence = UnoPropertiesHandler::buildPropertiesSequence (ListsFactory::createListExpandingItems <string> (UnoDispatchesCommonArgumentEnumerablePropertyNamesSet::c_instance.getValues (), UnoExtendedStringHandler::getString (a_unoDispatchSlot.c_urlInURL.Path)), ListsFactory::createList <Any, Any> (Any (true), *l_unoDispatchArgumentValuesIterator));
					 }
					 else {
						l_unoDispatchArgumentPropertiesSequence = UnoPropertiesHandler::buildPropertiesSequence (UnoDispatchesCommonArgumentEnumerablePropertyNamesSet::c_instance.getValues (), ListsFactory::createList <Any> (Any (true)));
					 }
				}
				::com::sun::star::util::URL l_urlInURL (a_unoDispatchSlot.c_urlInURL);
				UnoObjectPointer <XNotifyingDispatch> l_unoDispatcher (getUnoDispatcher (l_urlInURL));
				if (!l_unoDispatcher.isEmpty ()) {
					l_unoDispatcher->addStatusListener (this, l_urlInURL);
					l_unoDispatcher->dispatchWithNotification (l_urlInURL, l_unoDispatchArgumentPropertiesSequence, this);
					l_unoDispatcher->removeStatusListener (this, l_urlInURL);
				}
				else {
					i_dispatchResultAndRelatedInformation = nullptr;
				}
				return optional <UnoDispatchResultAndRelatedInformation> (*i_dispatchResultAndRelatedInformation);
			}
		}
	}
}

