#ifndef __theBiasPlanet_unoUtilities_pointers_UnoObjectPointer_hpp__
	#define __theBiasPlanet_unoUtilities_pointers_UnoObjectPointer_hpp__
	
	#include <optional>
	#include <list>
	#include <map>
	#include <memory>
	#include <string>
	#include <com/sun/star/uno/Reference.hxx>
	#include "theBiasPlanet/coreUtilities/collections/NavigableLinkedMap.hpp"
	#include "theBiasPlanet/unoUtilities/visualCplusplusSpecificHeaders/VisualCplusplusSpecificDefinitions.hpp"
	
	using namespace ::std;
	using namespace ::com::sun::star::uno;
	using namespace ::theBiasPlanet::coreUtilities::collections;
	
	namespace theBiasPlanet {
		namespace unoUtilities {
			namespace pointers {
				class __theBiasPlanet_unoUtilities_symbolExportingOrImportingForVisualCplusplus__ UnoObjectPointersInformationDumpCondition {
					public:
						static optional <string> c_unoObjectsInformationDumpFilePathString;
				};
				
				template <typename T> class UnoObjectPointer {
					private:
						static void unoInterfaceNameToPointerInReferenceMapDeleter (map <string const, void * const> * a_pointer);
						T * i_primaryAddress = nullptr;
						shared_ptr <map <string const, void * const>> i_unoInterfaceNameToPointerInReferenceMap;
						virtual void initialize ();
					public:
						static void setUnoObjectsInformationDumpFilePathString (string const & a_unoObjectsInformationDumpFilePathString);
						UnoObjectPointer ();
						UnoObjectPointer (T * const a_primaryAddress);
						UnoObjectPointer (Reference <T> const & a_primaryAddressPointer);
						//template <typename U> UnoObjectPointer (Reference <U> const & a_sourcePointer, bool const & a_targetAddressIsQueried = true, typename enable_if <!is_same <T, U>::value>::type * a_dummy = nullptr);
						template <typename U> UnoObjectPointer (Reference <U> const & a_sourcePointer, typename enable_if <!is_same <T, U>::value>::type * a_dummy = nullptr);
						template <typename U> UnoObjectPointer (UnoObjectPointer <U> & a_sourcePointer, bool const & a_targetAddressIsQueried = true, typename enable_if <!is_same <T, U>::value>::type * a_dummy = nullptr);
						template <typename U> UnoObjectPointer (UnoObjectPointer <U> && a_sourcePointer, bool const & a_targetAddressIsQueried = true, typename enable_if <!is_same <T, U>::value>::type * a_dummy = nullptr);
						UnoObjectPointer (UnoObjectPointer <T> const & a_sourcePointer);
						UnoObjectPointer <T> & operator = (UnoObjectPointer <T> const & a_sourcePointer);
						virtual ~UnoObjectPointer ();
						virtual list <string> getUnoTypeNames ();
						virtual NavigableLinkedMap <string, Any> getPropertyNameToValueMap ();
						virtual bool isEmpty ();
						virtual void setPrimaryAddress (T * const a_primaryAddress);
						virtual void setPrimaryAddress (Reference <T> const & a_primaryAddressPointer);
						template <typename U> void setPrimaryAddress (Reference <U> const & a_sourcePointer, typename enable_if <!is_same <T, U>::value>::type * a_dummy = nullptr);
						void setPrimaryAddress (UnoObjectPointer <T> & a_sourcePointer);
						template <typename U> void setPrimaryAddress (UnoObjectPointer <U> & a_sourcePointer, bool const & a_targetAddressIsQueried = true, typename enable_if <!is_same <T, U>::value>::type * a_dummy = nullptr);
						template <typename U> void setPrimaryAddress (UnoObjectPointer <U> && a_sourcePointer, bool const & a_targetAddressIsQueried = true, typename enable_if <!is_same <T, U>::value>::type * a_dummy = nullptr);
						virtual void clear ();
						virtual T & operator * ();
						virtual T * const operator -> ();
						virtual Reference <T> & getPointerInReference ();
						template <typename U> Reference <U> & getPointerInReference (bool const & a_pointerIsQueried = true, typename enable_if <!is_same <T, U>::value>::type * a_dummy = nullptr);
						virtual shared_ptr <map <string const, void * const>> const & getUnoInterfaceNameToPointerInReferenceMap ();
				};
			}
		}
	}
#endif

