#include "theBiasPlanet/unoUtilities/processesHandling/UnoProcessEnvironment.hpp"
#include <map>
#include <com/sun/star/uno/Any.h>
#include <com/sun/star/uno/XComponentContext.hpp>
#include <cppuhelper/bootstrap.hxx>
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoMessagesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoObjectsContextPropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::std;
using namespace ::com::sun::star::uno;
using namespace ::cppu;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups::propertyNamesSets;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace processesHandling {
			UnoObjectPointer <LocalUnoObjectsContext> UnoProcessEnvironment::createLocalUnoObjectsContext (string const & a_unoConnectionIdentification) {
				try {
					return UnoObjectPointer <LocalUnoObjectsContext> (new LocalUnoObjectsContext (defaultBootstrap_InitialComponentContext (), a_unoConnectionIdentification));
				}
				catch (Exception & l_exception) {
					throw l_exception;
				}
				catch (...) {
					exception_ptr l_currentException = current_exception ();
					throw runtime_error (UnoMessagesConstantsGroup::c_unoObjectsContextNotCreated);
				}
			}
			
			UnoProcessEnvironment::UnoProcessEnvironment (string const &  a_unoConnectionIdentification): i_localObjectsContext (createLocalUnoObjectsContext (a_unoConnectionIdentification)) {
			}
			
			UnoProcessEnvironment::~UnoProcessEnvironment () {
			}
			
			UnoObjectPointer <LocalUnoObjectsContext> & UnoProcessEnvironment::getLocalObjectsContext () {
				return i_localObjectsContext;
			}
		}
	}
}

