#include "theBiasPlanet/unoUtilities/propertiesHandling/UnoPropertiesHandler.hpp"
#include "theBiasPlanet/coreUtilities/constantsGroups/GeneralConstantsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/property/UnoProperty.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::theBiasPlanet::coreUtilities::constantsGroups;
using namespace ::theBiasPlanet::unoUtilities::property;
using namespace ::theBiasPlanet::unoUtilities::stringsHandling;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace propertiesHandling {
			Sequence <PropertyValue> UnoPropertiesHandler::buildPropertiesSequence (list <string> const & a_propertyNames, list <Any> const & a_propertyValues) {
				list <string> l_propertyNames;
				list <Any> l_propertyValues;
				list <Any>::const_iterator l_propertyValuesIterator = a_propertyValues.begin ();
				Any l_propertyValue;
				for (string l_propertyName: a_propertyNames) {
					l_propertyValue = *l_propertyValuesIterator;
					if (l_propertyValue.hasValue ()) {
						l_propertyNames.push_back (l_propertyName);
						l_propertyValues.push_back (l_propertyValue);
					}
					l_propertyValuesIterator ++;
				}
				Sequence <PropertyValue> l_propertiesSequence (l_propertyNames.size ());
				l_propertyValuesIterator = l_propertyValues.begin ();
				int l_propertyIndex = GeneralConstantsConstantsGroup::c_iterationStartNumber;
				for (string l_propertyName: l_propertyNames) {
					if (l_propertyName.find (string ("#")) != 0) {
						l_propertiesSequence [l_propertyIndex].Name = UnoExtendedStringHandler::getOustring (l_propertyName);
						l_propertiesSequence [l_propertyIndex].Handle =  -1;
					}
					else {
						l_propertiesSequence [l_propertyIndex].Name = UnoExtendedStringHandler::getOustring (string (""));
						l_propertiesSequence [l_propertyIndex].Handle =  stol (l_propertyName.substr (GeneralConstantsConstantsGroup::c_iterationStartNumber), nullptr, 10);
					}
					l_propertiesSequence [l_propertyIndex].Value = *l_propertyValuesIterator;
					l_propertyValuesIterator ++;
					l_propertyIndex ++;
				}
				return l_propertiesSequence;
			}
		}
	}
}

