#include "theBiasPlanet/unoUtilities/servicesHandling/GlobalUnoServicesProviderUtility.hpp"
#include <uno/lbnames.h>
#include "theBiasPlanet/coreUtilities/constantsGroups/GeneralConstantsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/stringsHandling/UnoExtendedStringHandler.hpp"

using namespace ::theBiasPlanet::coreUtilities::constantsGroups;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace servicesHandling {
			GlobalUnoServicesProviderUtility::UnoComponentCommonMethods::UnoComponentCommonMethods (ComponentFactoryFunc a_createInstanceMethod, OUString (* a_getClassNameMethod) (), Sequence <OUString> (* a_getUnoServiceNamesMethod) ()) : i_createInstanceMethod (a_createInstanceMethod), i_getClassNameMethod (a_getClassNameMethod), i_getUnoServiceNamesMethod (a_getUnoServiceNamesMethod) {
			}
			
			ComponentFactoryFunc GlobalUnoServicesProviderUtility::UnoComponentCommonMethods::getCreateInstanceMethod () {
				return i_createInstanceMethod;
			}
			
			OUString (*GlobalUnoServicesProviderUtility::UnoComponentCommonMethods::getGetClassNameMethod  ()) () {
				return i_getClassNameMethod;
			}
			
			Sequence <OUString> (* GlobalUnoServicesProviderUtility::UnoComponentCommonMethods::getGetUnoServiceNamesMethod ()) () {
				return i_getUnoServiceNamesMethod;
			}
			
			void * GlobalUnoServicesProviderUtility::getSingleUnoComponentInstancesFactory (map <string, UnoComponentCommonMethods> a_unoComponentClassNameToUnoComponentCommonMethodsMap, string a_unoComponentClassName, XMultiServiceFactory * a_unoGlobalServicesManagerInXMultiServiceFactory, XRegistryKey * a_registryKeyInXRegistryKey, ImplementationEntry * a_unoComponentEntries) {
				UnoComponentCommonMethods & l_unoComponentCommonMethods = a_unoComponentClassNameToUnoComponentCommonMethodsMap.at (a_unoComponentClassName);
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber].create = l_unoComponentCommonMethods.getCreateInstanceMethod ();
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber].createFactory = createSingleComponentFactory;
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber].getImplementationName = l_unoComponentCommonMethods.getGetClassNameMethod ();
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber].getSupportedServiceNames = l_unoComponentCommonMethods.getGetUnoServiceNamesMethod ();
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber].moduleCounter = nullptr; // This member is a dummy.
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber].nFlags = 0; // This member is a dummy for possible future extensions.
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber + 1].create = nullptr;
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber + 1].createFactory = nullptr;
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber + 1].getImplementationName = nullptr;
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber + 1].getSupportedServiceNames = nullptr;
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber + 1].moduleCounter = nullptr; // This member is a dummy.
				a_unoComponentEntries [GeneralConstantsConstantsGroup::c_iterationStartNumber + 1].nFlags = 0; // This member is a dummy for possible future extensions.
				return component_getFactoryHelper (a_unoComponentClassName.c_str (), a_unoGlobalServicesManagerInXMultiServiceFactory, a_registryKeyInXRegistryKey, a_unoComponentEntries);
			}
		}
	}
}

extern "C" {
	SAL_DLLPUBLIC_EXPORT void SAL_CALL component_getImplementationEnvironment (char const ** a_environmentTypeNameAddress, uno_Environment ** a_unoEnvironment) {
		*a_environmentTypeNameAddress = CPPU_CURRENT_LANGUAGE_BINDING_NAME;
	}
}

