#include <regex>
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoCharactersEncodingCodesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoDefaultValuesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoDispatchSlotsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoDocumentEventNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoFileNameSuffixesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoDocumentStoringFilterNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoGeneralConstantsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoMacroLocationNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoMessagesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoRegularExpressionsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoServiceNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoSingletonNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoSpecialFileUrlsConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/UnoSpecialFrameNamesConstantsGroup.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoDispatchesCommonArgumentEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoDocumentOpeningEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoDocumentStoringEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoObjectsContextPropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoPdfExportingPropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/UnoSpreadSheetPropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/Uno_uno_GoToCellEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/Uno_uno_GoToCellEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/constantsGroups/propertyNamesSets/Uno_uno_StyleNewByExampleEnumerablePropertyNamesSet.hpp"
#include "theBiasPlanet/unoUtilities/cryptographyHandling/MicrosoftPasswordsHasher.hpp"
#include "theBiasPlanet/unoUtilities/fileConversionsHandling/FilesConverter.hpp"
#include "theBiasPlanet/unoUtilities/pointers/UnoObjectPointer.hpp"
#include "theBiasPlanet/coreUtilities/stringsHandling/StringHandler.hpp"

using namespace ::theBiasPlanet::coreUtilities::stringsHandling;
using namespace ::theBiasPlanet::unoUtilities::constantsGroups::propertyNamesSets;

namespace theBiasPlanet {
	namespace unoUtilities {
		namespace constantsGroups {
			int const UnoCharactersEncodingCodesConstantsGroup::c_utf8 (76);
			int const UnoCharactersEncodingCodesConstantsGroup::c_ucs2 (65535);
			int const UnoCharactersEncodingCodesConstantsGroup::c_ucs4 (65534);
			int const UnoCharactersEncodingCodesConstantsGroup::c_usAscii (11);
			int const UnoCharactersEncodingCodesConstantsGroup::c_eucJp (69);
			int const UnoCharactersEncodingCodesConstantsGroup::c_shiftJis (64);
			string const UnoDefaultValuesConstantsGroup::c_customDefaultStyleName ("CustomDefault");
			string const UnoDefaultValuesConstantsGroup::c_initiallyOfferedUnoObjectName ("theBiasPlanet.UnoObjectsContext");
			string const UnoDocumentEventNamesConstantsGroup::c_documentDatumLoaded ("OnLoadFinished");
			string const UnoDocumentEventNamesConstantsGroup::c_titleChanged ("OnTitleChanged");
			string const UnoDocumentEventNamesConstantsGroup::c_focused ("OnFocus");
			string const UnoDocumentEventNamesConstantsGroup::c_viewCreated ("OnViewCreated");
			string const UnoDocumentEventNamesConstantsGroup::c_pagesCountChanged ("OnPageCountChange");
			string const UnoDocumentEventNamesConstantsGroup::c_frameDatumLoaded ("OnLoad");
			string const UnoDocumentEventNamesConstantsGroup::c_layouted ("OnLayoutFinished");
			string const UnoDocumentEventNamesConstantsGroup::c_preparingViewClosing ("OnPrepareViewClosing");
			string const UnoDocumentEventNamesConstantsGroup::c_preparingFrameUnloading ("OnPrepareUnload");
			string const UnoDocumentEventNamesConstantsGroup::c_viewClosed ("OnViewClosed");
			string const UnoDocumentEventNamesConstantsGroup::c_frameUnloaded ("OnUnload");
			string const UnoDocumentEventNamesConstantsGroup::c_unfocused ("OnUnfocus");
			string const UnoFileNameSuffixesConstantsGroup::c_unoIdlFileNameSuffix ("idl");
			string const UnoFileNameSuffixesConstantsGroup::c_unoDataTypesMergedRegistryFileNameSuffix ("rdb");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toOpenDocumentTextFileFilterName ("writer8");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toOpenDocumentSpreadsheetFileFilterName ("calc8");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toOpenDocumentPresentationFileFilterName ("impress8");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftWord97FileFilterName = ("MS Word 97");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftWord2007XmlFileFilterName ("MS Word 2007 XML");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftExcel97FileFilterName ("MS Excel 97");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftExcel2007XmlFileFilterName ("Calc MS Excel 2007 XML");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftPowerPoint97FileFilterName ("MS PowerPoint 97");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toMicrosoftPowerPoint2007XmlFileFilterName ("Impress MS PowerPoint 2007 XML");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toCsvFileFilterName ("Text - txt - csv (StarCalc)");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForTextDocuments ("writer_pdf_Export");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForSpreadSheetsDocuments ("calc_pdf_Export");
			string const UnoDocumentStoringFilterNamesConstantsGroup::c_toPdfFileFilterNameForPresentationDocuments ("impress_pdf_Export");
			string const UnoGeneralConstantsConstantsGroup::c_unspecifiedString ("");
			char const UnoGeneralConstantsConstantsGroup::c_digitPlaceCharacter ('0');
			double const UnoGeneralConstantsConstantsGroup::c_numberExpressionModelNumber (0.0);
			string const UnoGeneralConstantsConstantsGroup::c_cellPositionExpressionFormat ("$%s$%s");
			int const UnoGeneralConstantsConstantsGroup::c_rowIndexToRowPositionExpressionDifference (-1);
			string const UnoGeneralConstantsConstantsGroup::c_connectionUrlDelimiter (";");
			string const UnoGeneralConstantsConstantsGroup::c_moduleDlimiter ("::");
			string const UnoGeneralConstantsConstantsGroup::c_unoServiceNameFormat ("%s.%s");
			string const UnoGeneralConstantsConstantsGroup::c_singletonUrlFormat ("/singletons/%s");
			string const UnoGeneralConstantsConstantsGroup::c_unoIdlFileNameFormat (StringHandler::format ("%%s.%s", UnoFileNameSuffixesConstantsGroup::c_unoIdlFileNameSuffix));
			string const UnoGeneralConstantsConstantsGroup::c_unoModuleStartRelativeExpressionFormat ("module %s {");
			string const UnoGeneralConstantsConstantsGroup::c_unoModuleEndRelativeExpressionFormat ("};");
			string const UnoMacroLocationNamesConstantsGroup::c_userInPlace ("user");
			string const UnoMacroLocationNamesConstantsGroup::c_userInExtension ("user:uno_packages");
			string const UnoMacroLocationNamesConstantsGroup::c_applicationInPlace ("share");
			string const UnoMacroLocationNamesConstantsGroup::c_applicationInExtension ("share:uno_packages");
			string const UnoMacroLocationNamesConstantsGroup::c_document ("document");
			string const UnoMessagesConstantsGroup::c_remoteInstanceNotProvided ("The server didn't provide the remote instance.");
			string const UnoMessagesConstantsGroup::c_cellNotString ("The cell isn't a string value cell.");
			string const UnoMessagesConstantsGroup::c_unoDocumentNotSpecified ("The UNO document isn't specified.");
			string const UnoMessagesConstantsGroup::c_isNotSpreadSheetsDocument ("The specified UNO component is not a spread sheets document.");
			string const UnoMessagesConstantsGroup::c_isNotTextDocument ("The specified UNO component is not a text document.");
			string const UnoMessagesConstantsGroup::c_spreadSheetsDocumentNotSpecified ("The spread sheets document isn't specified.");
			string const UnoMessagesConstantsGroup::c_spreadSheetNotSpecified ("The spread sheet isn't specified.");
			string const UnoMessagesConstantsGroup::c_unoObjectsContextNotCreated ("Couldn't create the component context.");
			string const UnoMessagesConstantsGroup::c_unoObjectsContextNotSpecified ("The component context isn't specified.");
			string const UnoMessagesConstantsGroup::c_noCurrentSpreadSheetCell ("there is no current spread sheet cell.");
			regex const UnoRegularExpressionsConstantsGroup::c_urlRegularExpression ("(.*:)(.*)");
			string const UnoServiceNamesConstantsGroup::c_com_sun_star_frame_Desktop ("com.sun.star.frame.Desktop");
			string const UnoServiceNamesConstantsGroup::c_com_sun_star_frame_DispatchHelper ("com.sun.star.frame.DispatchHelper");
			string const UnoServiceNamesConstantsGroup::c_com_sun_star_xml_crypto_SecurityEnvironment ("com.sun.star.xml.crypto.SecurityEnvironment");
			string const UnoServiceNamesConstantsGroup::c_com_sun_star_bridge_BridgeFactory ("com.sun.star.bridge.BridgeFactory");
			string const UnoServiceNamesConstantsGroup::c_com_sun_star_connection_Connector ("com.sun.star.connection.Connector");
			string const UnoServiceNamesConstantsGroup::c_com_sun_star_connection_Acceptor ("com.sun.star.connection.Acceptor");
			string const UnoServiceNamesConstantsGroup::c_com_sun_star_util_URLTransformer ("com.sun.star.util.URLTransformer");
			string const UnoServiceNamesConstantsGroup::c_com_sun_star_xml_crypto_SEInitializer ("com.sun.star.xml.crypto.SEInitializer");
			string const UnoServiceNamesConstantsGroup::c_com_sun_star_xml_crypto_GPGSEInitializer ("com.sun.star.xml.crypto.GPGSEInitializer");
			string const UnoServiceNamesConstantsGroup::c_com_sun_star_xml_crypto_NSSInitializer ("com.sun.star.xml.crypto.NSSInitializer");
			string const UnoSingletonNamesConstantsGroup::c_com_sun_star_frame_theDesktop ("com.sun.star.frame.theDesktop");
			string const UnoSingletonNamesConstantsGroup::c_com_sun_star_frame_theGlobalEventBroadcaster ("com.sun.star.frame.theGlobalEventBroadcaster");
			string const UnoSpecialFileUrlsConstantsGroup::c_calcNewDocument ("private:factory/scalc");
			string const UnoSpecialFileUrlsConstantsGroup::c_writerNewDocument ("private:factory/swriter");
			string const UnoSpecialFrameNamesConstantsGroup::c_new ("_blank");
			string const UnoSpecialFrameNamesConstantsGroup::c_default ("_default");
			string const UnoSpecialFrameNamesConstantsGroup::c_self ("_self");
			string const UnoSpecialFrameNamesConstantsGroup::c_parent ("_parent");
			string const UnoSpecialFrameNamesConstantsGroup::c_top ("_top");
			string const UnoSpecialFrameNamesConstantsGroup::c_specialSub ("_beamer");
			namespace propertyNamesSets {
				string const UnoDispatchesCommonArgumentEnumerablePropertyNamesSet::c_synchronousMode_boolean ("SynchronMode");
				UnoDispatchesCommonArgumentEnumerablePropertyNamesSet const UnoDispatchesCommonArgumentEnumerablePropertyNamesSet::c_instance;
				string const UnoDocumentOpeningEnumerablePropertyNamesSet::c_readOnly_boolean ("ReadOnly");
				string const UnoDocumentOpeningEnumerablePropertyNamesSet::c_hidden_boolean ("Hidden");
				string const UnoDocumentOpeningEnumerablePropertyNamesSet::c_openNewView_boolean ("OpenNewView");
				string const UnoDocumentOpeningEnumerablePropertyNamesSet::c_silent_boolean ("Silent");
				string const UnoDocumentOpeningEnumerablePropertyNamesSet::c_password_string ("Password");
				UnoDocumentOpeningEnumerablePropertyNamesSet const UnoDocumentOpeningEnumerablePropertyNamesSet::c_instance;
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_filterName_string ("FilterName");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_filterData_any ("FilterData");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_filterData_string ("FilterOptions");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_isTemplate_boolean ("AsTemplate");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_authorName_string ("Author");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_title_string ("DocumentTitle");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_encryptionData_NamedValuesSequence ("EncryptionData");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_password_string ("Password");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_charactersSet_string ("CharacterSet");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_version_short ("Version");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_versionDescription_string ("Comment");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_overwrites_boolean ("Overwrite");
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_documentTypeSpecificData_any ("ComponentData"); // supposed to be, but not necessarily, a sequence of com.sun.star.beans.NamedValue
				string const UnoDocumentStoringEnumerablePropertyNamesSet::c_editingPasswordInformation_any ("ModifyPasswordInfo");
				UnoDocumentStoringEnumerablePropertyNamesSet const UnoDocumentStoringEnumerablePropertyNamesSet::c_instance;
				string const UnoObjectsContextPropertyNamesSet::c_unoConnectionIdentification_string ("unoConnectionIdentification");
				string const UnoObjectsContextPropertyNamesSet::c_unoConnectionSingleton_string (StringHandler::format (UnoGeneralConstantsConstantsGroup::c_singletonUrlFormat, string ("theBiasPlanet.unoUtilities.connection.UnoConnection")));
				string const UnoObjectsContextPropertyNamesSet::c_unoDesktopSingleton_string (StringHandler::format (UnoGeneralConstantsConstantsGroup::c_singletonUrlFormat, string ("theBiasPlanet.unoUtilities.displayElements.UnoDesktop")));
				string const UnoObjectsContextPropertyNamesSet::c_unoOfficeInstanceSingleton_string (StringHandler::format (UnoGeneralConstantsConstantsGroup::c_singletonUrlFormat, string ("theBiasPlanet.unoUtilities.officeInstance.OfficeInstance")));
				// General
				string const UnoPdfExportingPropertyNamesSet::c_pagesRangeSpecification_string ("PageRange"); // '' -> all the pages, '1-2,4', etc.
				string const UnoPdfExportingPropertyNamesSet::c_exportedSections_any ("Selection"); // the selection gotten by 'XSelectionSupplier.getSelection ()' of the controller of the document, or an arbitrary object (for example, a cells range)
				string const UnoPdfExportingPropertyNamesSet::c_losslessCompressionIsUsed_boolean ("UseLosslessCompression"); // 'false' -> a JPEG compression is used
				string const UnoPdfExportingPropertyNamesSet::c_jpegQuality_short ("Quality"); // in %
				string const UnoPdfExportingPropertyNamesSet::c_imageResolutionsAreReduced_boolean ("ReduceImageResolution");
				string const UnoPdfExportingPropertyNamesSet::c_maximumImageResolution_short ("MaxImageResolution"); // in DPI: 75, 150, 300, 600, or 1200
				string const UnoPdfExportingPropertyNamesSet::c_watermarkString_string ("Watermark");
				string const UnoPdfExportingPropertyNamesSet::c_originalDocumentIsEmbedded_boolean ("IsAddStream");
				string const UnoPdfExportingPropertyNamesSet::c_pdfVersionCode_short ("SelectPdfVersion"); // '0' -> PDF 1.4, '1' -> PDF/A-1
				string const UnoPdfExportingPropertyNamesSet::c_taggedPdfIsUsed_boolean ("UseTaggedPDF");
				string const UnoPdfExportingPropertyNamesSet::c_formFieldsAreExported_boolean ("ExportFormFields");
				string const UnoPdfExportingPropertyNamesSet::c_formsTypeCode_short ("FormsType"); // '0' -> FDF, '1' -> PDF, '2' -> HTML, '3' -> XML
				string const UnoPdfExportingPropertyNamesSet::c_someDuplicateFieldNamesAreAllowed_boolean ("AllowDuplicateFieldNames");
				string const UnoPdfExportingPropertyNamesSet::c_bookmarksAreExported_boolean ("ExportBookmarks");
				string const UnoPdfExportingPropertyNamesSet::c_placeholdersAreExported_boolean ("ExportPlaceholders");
				string const UnoPdfExportingPropertyNamesSet::c_commentsAreExported_boolean ("ExportNotes");
				string const UnoPdfExportingPropertyNamesSet::c_automaticallyInsertedEmptyPagesAreSkipped_boolean ("IsSkipEmptyPages");
				string const UnoPdfExportingPropertyNamesSet::c_formXobjectsAreUsed_boolean ("UseReferenceXObject");
				string const UnoPdfExportingPropertyNamesSet::c_targetFileIsShownAfterExportingHasBeenCompleted_boolean ("ViewPDFAfterExport");
				// Initial View
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileInitialViewStyleCode_short ("InitialView"); // '0' -> pages only, '1' -> bookmarks and pages, '2' -> thumbnails and pages
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileInitialPageNumber_short ("InitialPage");
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileInitialMagnificationTypeCode_short ("Magnification"); // '0' -> default, '1' -> the whole page is fitted into the window, '2' -> the page width is fitted into the window, '3' -> the page contents are supposed to be fitted into the window, but not necessarily are so
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileInitialZoomFactor_short ("Zoom"); // in %
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileInitialPageLayoutStyleCode_short ("PageLayout"); // '0' -> default, '1' -> single page, '2' -> continuous, '3' -> each 2 facing pages are shown abreast and those pairs are shown continuously connected vertically
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileFirstPageIsOnLeft_boolean ("FirstPageOnLeft"); // valid only when 'PageLayout' is '3'
				// User Interface
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileWindowIsResizedToInitialPage_boolean ("ResizeWindowToInitialPage");
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileWindowIsCenteredOnScreen_boolean ("CenterWindow");
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileWindowIsOpenedInFullScreenMode_boolean ("OpenInFullScreenMode");
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileDocumentTitleIsShown_boolean ("DisplayPDFDocumentTitle");
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileTransitionEffectsAreUsed_boolean ("UseTransitionEffects");
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileMenubarIsHidden_boolean ("HideViewerMenubar");
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileToolbarIsHidden_boolean ("HideViewerToolbar");
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileWindowControlsAreHidden_boolean ("HideViewerWindowControls");
				string const UnoPdfExportingPropertyNamesSet::c_forAfterExportingShowingOfTargetFileOpenedBookmarkLevels_short ("OpenBookmarkLevels"); // '-1' -> all
				// Links
				string const UnoPdfExportingPropertyNamesSet::c_bookmarksAreExportedAsNamedDestinations_boolean (" ExportBookmarksToPDFDestination");
				string const UnoPdfExportingPropertyNamesSet::c_documentLinksAreConvertedToPdfTargets_boolean ("ConvertOOoTargetToPDFTarget");
				string const UnoPdfExportingPropertyNamesSet::c_relativeFileLinksAreExported_boolean ("ExportLinksRelativeFsys");
				string const UnoPdfExportingPropertyNamesSet::c_crossDocumentsLinksViewerCode_short ("PDFViewSelection"); // '0' -> the default viewer, '1' -> a PDF reader application, '2' -> an internet browser
				// Security
				string const UnoPdfExportingPropertyNamesSet::c_fileIsEncrypted_boolean ("EncryptFile");
				string const UnoPdfExportingPropertyNamesSet::c_openingPassword_string ("DocumentOpenPassword");
				string const UnoPdfExportingPropertyNamesSet::c_someActionsAreRestricted_boolean ("RestrictPermissions");
				string const UnoPdfExportingPropertyNamesSet::c_restrictedActionsPassword_string ("PermissionPassword");
				string const UnoPdfExportingPropertyNamesSet::c_printingRestrictionCode_short ("Printing"); // '0' -> not permitted, '1' -> only in a low resolution (150 DPI), '2' -> also in high resolutions
				string const UnoPdfExportingPropertyNamesSet::c_changingRestrictionCode_short ("Changes"); // '0' -> not permitted, '1' -> inserting, deleting, and rotating pages, '2' -> filling in form fields, '3' -> commenting and filling in form fields, '4' -> any except extracting pages
				string const UnoPdfExportingPropertyNamesSet::c_copyingOfContentsIsAllowed_boolean ("EnableCopyingOfContent");
				string const UnoPdfExportingPropertyNamesSet::c_textAccessForAccessibilityToolsIsAllowed_boolean ("EnableTextAccessForAccessibilityTools");
				// Digital Signature
				string const UnoPdfExportingPropertyNamesSet::c_fileIsSigned_boolean ("SignPDF");
				string const UnoPdfExportingPropertyNamesSet::c_signatureCertificate_com_sun_star_security_XCertificate ("SignatureCertificate");
				string const UnoPdfExportingPropertyNamesSet::c_signatureCertificatePassword_string ("SignaturePassword");
				string const UnoPdfExportingPropertyNamesSet::c_signatureLocation_string ("SignatureLocation");
				string const UnoPdfExportingPropertyNamesSet::c_signatureReason_string ("SignatureReason");
				string const UnoPdfExportingPropertyNamesSet::c_signatureContactInformation_string ("SignatureContactInfo");
				string const UnoPdfExportingPropertyNamesSet::c_signatureTimeStampAuthorityUrl_string ("SignatureTSA");
				string const UnoSpreadSheetPropertyNamesSet::c_whetherIsVisible_boolean ("IsVisible");
				string const UnoSpreadSheetPropertyNamesSet::c_pageStyleName_string ("PageStyle");
				string const Uno_uno_GoToCellEnumerablePropertyNamesSet::c_destinationPoint_string ("ToPoint");
				Uno_uno_GoToCellEnumerablePropertyNamesSet const Uno_uno_GoToCellEnumerablePropertyNamesSet::c_instance;
				string const Uno_uno_StyleNewByExampleEnumerablePropertyNamesSet::c_styleName_string ("Param");
				string const Uno_uno_StyleNewByExampleEnumerablePropertyNamesSet::c_styleFamilyKey_short ("Family");
				Uno_uno_StyleNewByExampleEnumerablePropertyNamesSet Uno_uno_StyleNewByExampleEnumerablePropertyNamesSet::c_instance;
			}
			UnoDispatchSlotsConstantsGroup::BaseUnoDispatchSlot const UnoDispatchSlotsConstantsGroup::c__uno_GoToCell (string (".uno:GoToCell"), optional <BaseEnumerableConstantsGroup <string>> (Uno_uno_GoToCellEnumerablePropertyNamesSet::c_instance));
			UnoDispatchSlotsConstantsGroup::BaseUnoDispatchSlot const UnoDispatchSlotsConstantsGroup::c__uno_StyleNewByExample (string (".uno:StyleNewByExample"), optional <BaseEnumerableConstantsGroup <string>> (Uno_uno_StyleNewByExampleEnumerablePropertyNamesSet::c_instance));
			/*
					// This slot is removed.
					static BaseUnoDispatchSlot const c__uno_Cells = new BaseUnoDispatchSlot (".uno:Cells", Uno_uno_CellsEnumerablePropertyNamesSet.c_instance);
					// This slot is removed.
					static BaseUnoDispatchSlot const c__uno_Range = new BaseUnoDispatchSlot (".uno:Range", Uno_uno_RangeEnumerablePropertyNamesSet.c_instance);
					// This slot is removed.
					static BaseUnoDispatchSlot const c__uno_CellText = new BaseUnoDispatchSlot (".uno:CellText", Uno_uno_CellTextEnumerablePropertyNamesSet.c_instance);
					// This slot is removed.
					static BaseUnoDispatchSlot const c__uno_Selection = new BaseUnoDispatchSlot (".uno:Selection", null);
					// This slot is removed.
					static BaseUnoDispatchSlot const c__uno_ActiveCell = new BaseUnoDispatchSlot (".uno:ActiveCell", null);
					// This slot is removed.
					static BaseUnoDispatchSlot const c__uno_ActiveTable = new BaseUnoDispatchSlot (".uno:ActiveTable", null);
					// This slot is removed.
					static BaseUnoDispatchSlot const c__uno_Tables = new BaseUnoDispatchSlot (".uno:Tables", null);
					// This slot is removed.
					static BaseUnoDispatchSlot const c__uno_DataPilotTables = new BaseUnoDispatchSlot (".uno:DataPilotTables", null);
					static BaseUnoDispatchSlot const c__uno_Position = new BaseUnoDispatchSlot (".uno:Position", null);
					static BaseUnoDispatchSlot const c__uno_GoToCurrentCell = new BaseUnoDispatchSlot (".uno:GoToCurrentCell", null);
					static BaseUnoDispatchSlot const c__uno_StatusDocPos = new BaseUnoDispatchSlot (".uno:StatusDocPos", null);
					static BaseUnoDispatchSlot const c__uno_StatusSelectionMode = new BaseUnoDispatchSlot (".uno:StatusSelectionMode", null);
					static BaseUnoDispatchSlot const c__uno_StatusSelectionModeExp = new BaseUnoDispatchSlot (".uno:StatusSelectionModeExp", null);
					static BaseUnoDispatchSlot const c__uno_StatusSelectionModeExt = new BaseUnoDispatchSlot (".uno:StatusSelectionModeExt", null);
					static BaseUnoDispatchSlot const c__uno_StatusSelectionModeNorm = new BaseUnoDispatchSlot (".uno:StatusSelectionModeNorm", null);
					static BaseUnoDispatchSlot const c__uno_SelectData = new BaseUnoDispatchSlot (".uno:SelectData", null);
					static BaseUnoDispatchSlot const c__uno_SetInputMode = new BaseUnoDispatchSlot (".uno:SetInputMode", null);
					static BaseUnoDispatchSlot const c__uno_JumpToPreviousCell = new BaseUnoDispatchSlot (".uno:JumpToPreviousCell", null);
					static BaseUnoDispatchSlot const c__uno_DataSelect = new BaseUnoDispatchSlot (".uno:DataSelect", null);
					static BaseUnoDispatchSlot const c__uno_ExternalEdit = new BaseUnoDispatchSlot (".uno:ExternalEdit", null);
					static BaseUnoDispatchSlot const c__uno_PasteSpecial = new BaseUnoDispatchSlot (".uno:PasteSpecial", Uno_uno_PasteSpecialEnumerablePropertyNamesSet.c_instance);
					*/

		}
		namespace cryptographyHandling {
			int const MicrosoftPasswordsHasher::c_numberOfInitializationCodes (15);
			unsigned short const MicrosoftPasswordsHasher::c_initializationCodes [] {(unsigned short) 0xE1F0, (unsigned short) 0x1D0F, (unsigned short) 0xCC9C, (unsigned short) 0x84C0, (unsigned short) 0x110C, (unsigned short) 0x0E10, (unsigned short) 0xF1CE, (unsigned short) 0x313E, (unsigned short) 0x1872, (unsigned short) 0xE139, (unsigned short) 0xD40F, (unsigned short) 0x84F9, (unsigned short) 0x280C, (unsigned short) 0xA96A, (unsigned short) 0x4EC3};
			int const MicrosoftPasswordsHasher::c_numberOfEncryptionMatrixColumns;
			unsigned short const MicrosoftPasswordsHasher::c_encryptionMatrix [] [MicrosoftPasswordsHasher::c_numberOfEncryptionMatrixColumns] {
				{ (unsigned short) 0xAEFC, (unsigned short) 0x4DD9, (unsigned short) 0x9BB2, (unsigned short) 0x2745, (unsigned short) 0x4E8A, (unsigned short) 0x9D14, (unsigned short) 0x2A09},
				{ (unsigned short) 0x7B61, (unsigned short) 0xF6C2, (unsigned short) 0xFDA5, (unsigned short) 0xEB6B, (unsigned short) 0xC6F7, (unsigned short) 0x9DCF, (unsigned short) 0x2BBF},
				{ (unsigned short) 0x4563, (unsigned short) 0x8AC6, (unsigned short) 0x05AD, (unsigned short) 0x0B5A, (unsigned short) 0x16B4, (unsigned short) 0x2D68, (unsigned short) 0x5AD0},
				{ (unsigned short) 0x0375, (unsigned short) 0x06EA, (unsigned short) 0x0DD4, (unsigned short) 0x1BA8, (unsigned short) 0x3750, (unsigned short) 0x6EA0, (unsigned short) 0xDD40},
				{ (unsigned short) 0xD849, (unsigned short) 0xA0B3, (unsigned short) 0x5147, (unsigned short) 0xA28E, (unsigned short) 0x553D, (unsigned short) 0xAA7A, (unsigned short) 0x44D5},
				{ (unsigned short) 0x6F45, (unsigned short) 0xDE8A, (unsigned short) 0xAD35, (unsigned short) 0x4A4B, (unsigned short) 0x9496, (unsigned short) 0x390D, (unsigned short) 0x721A},
				{ (unsigned short) 0xEB23, (unsigned short) 0xC667, (unsigned short) 0x9CEF, (unsigned short) 0x29FF, (unsigned short) 0x53FE, (unsigned short) 0xA7FC, (unsigned short) 0x5FD9},
				{ (unsigned short) 0x47D3, (unsigned short) 0x8FA6, (unsigned short) 0x8FA6, (unsigned short) 0x1EDA, (unsigned short) 0x3DB4, (unsigned short) 0x7B68, (unsigned short) 0xF6D0},
				{ (unsigned short) 0xB861, (unsigned short) 0x60E3, (unsigned short) 0xC1C6, (unsigned short) 0x93AD, (unsigned short) 0x377B, (unsigned short) 0x6EF6, (unsigned short) 0xDDEC},
				{ (unsigned short) 0x45A0, (unsigned short) 0x8B40, (unsigned short) 0x06A1, (unsigned short) 0x0D42, (unsigned short) 0x1A84, (unsigned short) 0x3508, (unsigned short) 0x6A10},
				{ (unsigned short) 0xAA51, (unsigned short) 0x4483, (unsigned short) 0x8906, (unsigned short) 0x022D, (unsigned short) 0x045A, (unsigned short) 0x08B4, (unsigned short) 0x1168},
				{ (unsigned short) 0x76B4, (unsigned short) 0xED68, (unsigned short) 0xCAF1, (unsigned short) 0x85C3, (unsigned short) 0x1BA7, (unsigned short) 0x374E, (unsigned short) 0x6E9C},
				{ (unsigned short) 0x3730, (unsigned short) 0x6E60, (unsigned short) 0xDCC0, (unsigned short) 0xA9A1, (unsigned short) 0x4363, (unsigned short) 0x86C6, (unsigned short) 0x1DAD},
				{ (unsigned short) 0x3331, (unsigned short) 0x6662, (unsigned short) 0xCCC4, (unsigned short) 0x89A9, (unsigned short) 0x0373, (unsigned short) 0x06E6, (unsigned short) 0x0DCC},
				{ (unsigned short) 0x1021, (unsigned short) 0x2042, (unsigned short) 0x4084, (unsigned short) 0x8108, (unsigned short) 0x1231, (unsigned short) 0x2462, (unsigned short) 0x48C4}
			};
		}
		namespace fileConversionsHandling {
			string const FilesConverter::c_csvFormatStringFormat ("%d,%d,%d,1,,0,%b,false,%b,%b,false"); // the CSV items delimiter character code (can be specified like 'Character.codePointAt ("\t", 0)'), the CSV text items quotation character code (can be specified like 'Character.codePointAt ("\"", 0)'), the encoding code (76 -> UTF-8, 65535 -> UCS-2, 65534 -> UCS-4, 11 -> US-ASCII, 69 -> EUC_JP, 64 -> SHIFT_JIS), whether all the text items are quoted, whether the contents are exported as shown, whether the formula themselves are exported
		}
		namespace pointers {
			optional <string> UnoObjectPointersInformationDumpCondition::c_unoObjectsInformationDumpFilePathString (nullopt);
		}
	}
}

