namespace theBiasPlanet {
	namespace unoUtilities {
		namespace connectionsHandling {
			using System;
			using System.Collections.Generic;
			using unoidl.com.sun.star.connection;
			using theBiasPlanet.coreUtilities.stringsHandling;
			using theBiasPlanet.coreUtilities.messagingHandling;
			using theBiasPlanet.unoUtilities.connection;
			using theBiasPlanet.unoUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.unoObjectsContexts;
			
			public class UnoConnectionConnector: UnoConnectionsFactory {
				public UnoConnectionConnector (LocalUnoObjectsContext a_localUnoObjectsContext): base (a_localUnoObjectsContext) {
					initialize ();
				}
				
				~UnoConnectionConnector () {
				}
				
				public UnoConnection connect (String a_url, List <UnoConnection.UnoConnectionEventsListener> a_eventsListeners) {
					StringTokenizer l_urlTokenizer = new StringTokenizer (a_url, UnoGeneralConstantsConstantsGroup.c_connectionUrlDelimiter);
					XConnector l_unoConnectionConnector = (XConnector) i_localUnoObjectsContext.getUnoServiceInstance <XConnector> (UnoServiceNamesConstantsGroup.c_com_sun_star_connection_Connector, null);
					try {
						XConnection l_unoConnection = l_unoConnectionConnector.connect (l_urlTokenizer.nextToken ());
						return setUpUnoConnection (l_unoConnection, l_urlTokenizer, DateTime.Now.ToString (), a_eventsListeners);
					}
					catch (NoConnectException l_exception) {
						Publisher.logErrorInformation (l_exception);
						return null;
					}
				}
			}
		}
	}
}

