namespace theBiasPlanet {
	namespace unoUtilities {
		namespace connectionsHandling {
			using System;
			using System.Collections.Generic;
			using uno;
			using unoidl.com.sun.star.bridge;
			using unoidl.com.sun.star.connection;
			using unoidl.com.sun.star.uno;
			using theBiasPlanet.coreUtilities.stringsHandling;
			using theBiasPlanet.unoUtilities.connection;
			using theBiasPlanet.unoUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets;
			using theBiasPlanet.unoUtilities.pointers;
			using theBiasPlanet.unoUtilities.unoObjectsContexts;
			
			abstract public class UnoConnectionsFactory {
				protected LocalUnoObjectsContext i_localUnoObjectsContext = null;
				protected XBridgeFactory i_unoBridgesFactory = null;
				protected UnoConnectionsFactory (LocalUnoObjectsContext a_localUnoObjectsContext) {
					i_localUnoObjectsContext = a_localUnoObjectsContext;
				}
				
				~UnoConnectionsFactory () {
				}
				
				protected void initialize () {
					i_unoBridgesFactory = (XBridgeFactory) i_localUnoObjectsContext.getUnoServiceInstance <XBridgeFactory> (UnoServiceNamesConstantsGroup.c_com_sun_star_bridge_BridgeFactory, null);
				}
				
				protected UnoConnection setUpUnoConnection (XConnection a_unoConnection, StringTokenizer a_urlTokenizer, String a_unoConnectionIdentification, List <UnoConnection.UnoConnectionEventsListener> a_eventsListeners) {
					UnoConnection.InitialUnoObjectsProvider l_initialUnoObjectsProvider = new UnoConnection.InitialUnoObjectsProvider (i_localUnoObjectsContext);
					XBridge l_unoBridge = null;
					try {
						l_unoBridge = i_unoBridgesFactory.createBridge ("", a_urlTokenizer.nextToken (), a_unoConnection, l_initialUnoObjectsProvider);
					}
					catch (BridgeExistsException) {
						// This can't happen
					}
					UnoObjectPointer <XComponentContext> l_remoteUnoObjectsContext = new UnoObjectPointer <XComponentContext> (l_unoBridge.getInstance (a_urlTokenizer.nextToken ()));
					if (l_remoteUnoObjectsContext.isEmpty ()) {
						throw new System.Exception (UnoMessagesConstantsGroup.c_remoteInstanceNotProvided);
					}
					return new UnoConnection (l_remoteUnoObjectsContext, a_unoConnectionIdentification, l_unoBridge, l_initialUnoObjectsProvider, a_eventsListeners);
				}
			}
		}
	}
}

