namespace theBiasPlanet {
	namespace unoUtilities {
		namespace constantsGroups {
			namespace propertyNamesSets {
				using System;
				using theBiasPlanet.coreUtilities.constantsGroups;
				
				public class UnoTextPageStylePropertyNamesSet : UnoDocumentTypesCommonPageStylePropertyNamesSet {
					public const String c_pageStyleIsPhysical_boolean = "IsPhysical"; // read only and usually 'true'; unknown how a page style can be un-physical<!--???-->
					/*
					public const String c_pageIsInStandardPageMode_boolean = "StandardPageMode"; // ??? grid standard mode always 'false' ; not preserved
					*/
					public const String c_nextStyleName_string = "FollowStyle"; // 'Standard'
					/*
					public const String c_contentsVerticalAdjustment_com.sun.star.drawing.TextVerticalAdjust = "TextVerticalAdjust"; // ??? TOP, CENTER, BOTTOM, BLOCK  not preserved
					*/
					public const String c_nameOfParagraphStyleAccordingToWhoseSpacingTextLinesAreAlignedInInvisibleLinesGrid_string = "RegisterParagraphStyle"; // the name of the paragraph style according to whose spacing the lines are aligned in an invisible lines grid
					public const String c_textColums_com_sun_star_text_XTextColumns = "TextColumns"; // the text columns object
					public const String c_pageBackgroundStyle_com_sun_star_drawing_FillStyle = "FillStyle"; // 'FillStyle.NONE' -> none, 'FillStyle.SOLID' -> solid color, 'FillStyle.GRADIENT' -> gradient, 'FillStyle.HATCH' -> hatch, 'FillStyle.BITMAP' -> graphic or pattern
					public const String c_pageBackgroundIsFilled_boolean = "FillBackground"; // the page background is filled 
					public const String c_pageBackgroundTransparency_short = "FillTransparence"; // the page background transparency in %
					public const String c_pageBackgroundTransparencyGradientName_string = "FillTransparenceGradientName"; // "" -> nothing, "Transparency 2", etc.
					public const String c_pageBackgroundTransparencyGradient_com_sun_star_awt_Gradient = "FillTransparenceGradient";
					public const String c_pageBackgroundColor_duplicate_com_sun_star_util_Color = "FillColor"; // the page background color (duplicate of 'BackColor')
					/*
					public const String c_pageBackground2ndaryColor_com_sun_star_util_Color = "FillColor2"; // ??? Unknown how this is used
					*/
					public const String c_pageBackgroundGradientName_string = "FillGradientName"; // the background color gradient name: seems to be 'gradient' for any gradient type
					public const String c_pageBackgroundGradient_com_sun_star_awt_Gradient = "FillGradient"; // the background gradient

					public const String c_numberOfStepsOfPageBackgroundGradient_short = "FillGradientStepCount"; // the number of steps of the page background gradient

					public const String c_pageBackgroundGraphicOrPatternName_string = "FillBitmapName"; // the background graphic or pattern name
					public const String c_pageBackgroundGraphicUrlDuplicate_string = "FillBitmapURL"; // the background graphics URL vnd.sun.star.GraphicObject:100000000000005E0000005EAB6862D59EF3F3E6  
					public const String c_pageBackgroundGraphic_com_sun_star_awt_XBitmap = "FillBitmap"; // the background graphic
					public const String c_pageBackgroundGraphicFittingMode_com_sun_star_drawing_BitmapMode = "FillBitmapMode"; // the background graphics fitting mode REPEAT, STRETCH, NO_REPEAT
					public const String c_pageBackgroundGraphicIsStretched_boolean = "FillBitmapStretch"; // the background graphics is stretched
					public const String c_pageBackgroundGraphicIsTiled_boolean = "FillBitmapTile"; // the background graphic is tiled
					public const String c_pageBackgroundGraphicTilingHorizontalOffset_long = "FillBitmapPositionOffsetX"; // the background graphics tiling horizontal offset in %
					public const String c_pageBackgroundGraphicTilingVerticalOffset_long = "FillBitmapPositionOffsetY"; // the background graphics tiling vertical offset in %
					public const String c_pageBackgroundGraphicTilingRowsShift_long = "FillBitmapOffsetX"; // the background graphics tiling horizontal rows shift in %
					public const String c_pageBackgroundGraphicTilingColumnsShift_long = "FillBitmapOffsetY";// the background graphics tiling horizontal columns shift in %
					/*
					public const String c_pageBackgroundGraphicSizeIsLogical_boolean = "FillBitmapLogicalSize"; // ??? always true not preserved otherwise
					*/
					public const String c_pageBackgroundGraphicWidth_long = "FillBitmapSizeX"; // the background graphic width in hundredths of a millimeter
					public const String c_pageBackgroundGraphicHeight_long = "FillBitmapSizeY"; // the background graphic height in hundredths of a millimeter
					public const String c_pageBackgroundGraphicLocationInPage_com_sun_star_drawing_RectanglePoint = "FillBitmapRectanglePoint"; // the background graphic's location in the page
					public const String c_pageBackgroundHatchName_string = "FillHatchName"; // the background hatch name
					public const String c_pageBackgroundHatch_com_sun_star_drawing_Hatch = "FillHatch"; // the background hatch
					public const String c_gridIsDisplayed_boolean = "GridDisplay"; // the grid is displayed
					public const String c_gridIsPrinted_boolean = "GridPrint"; // the grid is printed
					public const String c_gridMode_short = "GridMode"; // the grid mode: 0 -> none, 1 -> lines, 2 -> lines and characters
					public const String c_gridSnapsToCharacters_boolean = "GridSnapToChars"; // seems not to be able to be changed from 'true' ???
					public const String c_numberOfGridLines_unsignedShort = "GridLines"; // the number of grid lines
					public const String c_gridColor_com_sun_star_util_Color = "GridColor"; // the grid color
					public const String c_gridBaseTextsMaximumWidth_long = "GridBaseWidth"; // the grid base texts maximum width in hundredths of a millimeter
					public const String c_gridBaseTextsMaximumHeight_long = "GridBaseHeight"; // the grid base texts maximum height in hundredths of a millimeter
					public const String c_gridRubiesMaximumyHeight_long = "GridRubyHeight"; // the grid rubies maximum height 
					public const String c_gridRubiesAreShownOnLeftOfOrBelowBaseTexts_boolean = "RubyBelow"; // Rubies are shown on the left of or below the base texts
					/*
					public const String c_pageShadowTransparency_byte = "ShadowTransparence"; // ??? set where
					*/
					public const String c_firstPageDoesNotHaveSpecificHeaderOrFooter_boolean = "FirstIsShared"; // the first page does not have any specific header or footer
					public const String c_pageHeaderSynchronizedText_com_sun_star_text_XText = "HeaderText"; // the synchronized header text
					public const String c_firstPageHeaderText_com_sun_star_text_XText = "HeaderTextFirst"; // the first page header text
					public const String c_leftPageHeaderText_com_sun_star_text_XText = "HeaderTextLeft"; // the left page header text
					public const String c_rightPageHeaderText_com_sun_star_text_XText = "HeaderTextRight"; // the right page header text
					public const String c_pageHeaderBackgroundStyle_com_sun_star_drawing_FillStyle = "HeaderFillStyle"; // hatch, color, . .. 
					public const String c_pageHeaderSpacingIsChangedImplicitly_boolean = "HeaderDynamicSpacing"; // the header spacing is changed implicitly
					public const String c_pageHeaderBackgroundIsFilled_boolean = "HeaderFillBackground";
					public const String c_pageHeaderBackgroundTransparency_short = "HeaderFillTransparence"; // the transparency in %
					public const String c_pageHeaderBackgroundTransparencyGradientName_string = "HeaderFillTransparenceGradientName"; // like "Transparency 3"
					public const String c_pageHeaderBackgroundTransparencyGradient_com_sun_star_awt_Gradient = "HeaderFillTransparenceGradient"; // the gradient object
					public const String c_pageHeaderBackgroundColorDuplicate_com_sun_star_util_Color = "HeaderFillColor"; // the background color
					/*
					public const String c_pageHeaderBackground2ndaryColor_com_sun_star_util_Color = "HeaderFillColor2"; // ??? Unknown how this is used
					*/
					public const String c_pageHeaderBackgroundGradientName_string = "HeaderFillGradientName"; // the name "gradient" always???
					public const String c_pageHeaderBackgroundGradient_com_sun_star_awt_Gradient = "HeaderFillGradient"; // the gradient object
					public const String c_numberOfStepsOfPageHeaderBackgroundGradient_short = "HeaderFillGradientStepCount"; // the gradient steps count
					public const String c_pageHeaderBackgroundGraphicOrPatternName_string = "HeaderFillBitmapName"; // the name
					public const String c_pageHeaderBackgroundGraphicUrlDuplicate_string = "HeaderFillBitmapURL"; // the header background graphics URL like ???
					public const String c_pageHeaderBackgroundGraphic_com_sun_star_awt_XBitmap = "HeaderFillBitmap";
					public const String c_pageHeaderBackgroundGraphicFittingMode_com_sun_star_drawing_BitmapMode = "HeaderFillBitmapMode"; // REPEAT, STRETCH, NO_REPEAT
					public const String c_pageHeaderBackgroundGraphicIsStretched_boolean = "HeaderFillBitmapStretch"; // the header background graphics is stretched
					public const String c_pageHeaderBackgroundGraphicIsTiled_boolean = "HeaderFillBitmapTile"; // is tiled
					public const String c_pageHeaderBackgroundGraphicTilingHorizontalOffset_long = "HeaderFillBitmapPositionOffsetX"; // %
					public const String c_pageHeaderBackgroundGraphicTilingVerticalOffset_long = "HeaderFillBitmapPositionOffsetY"; // the page header background graphic tiling vertical offset
					public const String c_pageHeaderBackgroundGraphicTilingRowsShift_long = "HeaderFillBitmapOffsetX"; // 
					public const String c_pageHeaderBackgroundGraphicTilingColumnsShift_long = "HeaderFillBitmapOffsetY"; // 
					/*
					public const String c_pageHeaderBackgroundGraphicSizeIsLogical_boolean??? = "HeaderFillBitmapLogicalSize"; // ???
					*/
					public const String c_pageHeaderBackgroundGraphicWidth_long = "HeaderFillBitmapSizeX";
					public const String c_pageHeaderBackgroundGraphicHeight_long = "HeaderFillBitmapSizeY"; // the header background graphics height in hundredths of a millimeter
					public const String c_pageHeaderBackgroundGraphicLocationInHeader_com_sun_star_drawing_RectanglePoint = "HeaderFillBitmapRectanglePoint"; // the location

					public const String c_pageHeaderBackgroundHatchName_string = "HeaderFillHatchName"; // the headwer background hatch name
					public const String c_pageHeaderBackgroundHatch_com_sun_star_drawing_Hatch = "HeaderFillHatch"; // the hatch
					public const String c_pageFooterSynchronizedText_com_sun_star_text_Text = "FooterText";
					public const String c_firstPageFooterText_com_sun_star_text_XText = "FooterTextFirst";
					public const String c_leftPageFooterText_com_sun_star_text_XText = "FooterTextLeft";
					public const String c_rightPageFooterText_com_sun_star_text_XText = "FooterTextRight";
					public const String c_pageFooterBackgroundStyle_com_sun_star_drawing_FillStyle = "FooterFillStyle"; // hatch, color, . .. 
					public const String c_pageFooterSpacingIsChangedImplicitly_boolean = "FooterDynamicSpacing";
					public const String c_pageFooterBackgroundIsFilled_boolean = "FooterFillBackground";
					public const String c_pageFooterBackgroundTransparency_short = "FooterFillTransparence"; // the transparency in %$
					public const String c_pageFooterBackgroundTransparenceGradientName_string = "FooterFillTransparenceGradientName"; // like "Transparency 3"
					public const String c_pageFooterBackgroundTransparencyGradient_com_sun_star_awt_Gradient = "FooterFillTransparenceGradient";
					public const String c_pageFooterBackgroundColorDuplicate_com_sun_star_util_Color = "FooterFillColor";
					/*
					public const String c_pageFooterBackground2ndaryColor_com_sun_star_util_Color = "FooterFillColor2"; // ??? Unknown how this is used
					*/
					public const String c_pageFooterBackgroundGradientName_string = "FooterFillGradientName"; // the name "gradient" always???
					public const String c_pageFooterBackgroundGradient_com_sun_star_awt_Gradient = "FooterFillGradient"; // the footer gradient object
					public const String c_numberOfStepsOfPageFooterBackgroundGradient_short = "FooterFillGradientStepCount"; // the gradient steps count
					public const String c_pageFooterBackgroundGraphicOrPatternName_string = "FooterFillBitmapName";
					public const String c_pageFooterBackgroundGraphicUrlDuplicate_string = "FooterFillBitmapURL"; // the header background graphics URL like ???
					public const String c_pageFooterBackgroundGraphic_com_sun_star_awt_XBitmap = "FooterFillBitmap";
					public const String c_pageFooterBackgroundGraphicFittingMode_com_sun_star_drawing_BitmapMode = "FooterFillBitmapMode"; // REPEAT, STRETCH, NO_REPEAT
					public const String c_pageFooterBackgroundGraphicIsStretched_boolean = "FooterFillBitmapStretch";
					public const String c_pageFooterBackgroundGraphicIsTiled_boolean = "FooterFillBitmapTile";
					public const String c_pageFooterBackgroundGraphicTilingHorizontalOffset_long = "FooterFillBitmapPositionOffsetX";
					public const String c_pageFooterBackgroundGraphicTilingVerticalOffset_long = "FooterFillBitmapPositionOffsetY";
					public const String c_pageFooterBackgroundGraphicTilingRowsShift_long = "FooterFillBitmapOffsetX";
					public const String c_pageFooterBackgroundGraphicTilingColumnsShift_long = "FooterFillBitmapOffsetY";
					/*
					public const String c_pageFooterBackgroundGraphicSizeIsLogical_boolean = "FooterFillBitmapLogicalSize"; // 'true' always ???
					*/
					public const String c_pageFooterBackgroundGraphicWidth_long = "FooterFillBitmapSizeX";
					public const String c_pageFooterBackgroundGraphicHeight_long = "FooterFillBitmapSizeY";
					public const String c_pageFooterBackgroundGraphicLocationInFooter_com_sun_star_drawing_RectanglePoint = "FooterFillBitmapRectanglePoint";
					public const String c_pageFooterBackgroundHatchName_string = "FooterFillHatchName";
					public const String c_pageFooterBackgroundHatch_com_sun_star_drawing_Hatch = "FooterFillHatch";
	
					public const String c_footnoteMaximumHeight_long = "FootnoteHeight"; // the footnote maximum height in hundredths of a millimeter
					public const String c_footnoteSpacing_long = "FootnoteLineTextDistance"; // space to main text in hundredths of a millimeter
					public const String c_footnoteLineStyle_byte = "FootnoteLineStyle"; // 0, -> none, 1 -> solid, etc.
					public const String c_footnoteLineWeight_short = "FootnoteLineWeight"; // Thickness 35 -> 1.00pt
					public const String c_footnoteLineColor_com_sun_star_util_Color = "FootnoteLineColor"; // color
					public const String c_footnoteSeparatorLineLocation_short = "FootnoteLineAdjust"; // the footnote separator line location 0 -> left, 1 -> center, 2 -> right
					public const String c_footnoteSeparatorLineRelativeWidth_byte = "FootnoteLineRelativeWidth"; // in % 
					public const String c_footnoteSeparatorLinePadding_long = "FootnoteLineDistance"; // padding to the footnote contents in hundredths of a millimeter
					// Invalid at least now	public const String c_textLinesAreAlignedInInvisibleLinesGrid_boolean = "RegisterModeActive";
				}
			}
		}
	}
}

