namespace theBiasPlanet {
	namespace unoUtilities {
		namespace displayElements {
			using System;
			using System.Collections.Generic;
			using System.IO;
			using uno;
			using unoidl.com.sun.star.container;
			using unoidl.com.sun.star.frame;
			using unoidl.com.sun.star.lang;
			using theBiasPlanet.coreUtilities.collectionsHandling;
			using theBiasPlanet.coreUtilities.constantsGroups;
			using theBiasPlanet.coreUtilities.stringsHandling;
			using theBiasPlanet.unoUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets;
			using theBiasPlanet.unoUtilities.dispatchingHandling;
			using theBiasPlanet.unoUtilities.pointers;
			using theBiasPlanet.unoUtilities.propertiesHandling;
			using theBiasPlanet.unoUtilities.unoComponentBases;
			using theBiasPlanet.unoUtilities.unoDataHandling;
			using theBiasPlanet.unoUtilities.unoObjectsContexts;
			
			public class UnoDesktop: UnoFrame {
				private UnoObjectPointer <XSynchronousDispatch> i_fileOpeningDispatcher = null;
				
				public static UnoDesktop getInstance (RemoteUnoObjectsContext a_remoteUnoObjectsContext) {
					return	new UnoDesktop (a_remoteUnoObjectsContext);
				}
				
				public UnoDesktop (RemoteUnoObjectsContext a_remoteUnoObjectsContext): base (a_remoteUnoObjectsContext, new UnoObjectPointer <XFrame> ( (XFrame) UnoDatumConverter.getObject (a_remoteUnoObjectsContext.getValueByName (String.Format (UnoGeneralConstantsConstantsGroup.c_singletonUrlFormat, UnoSingletonNamesConstantsGroup.c_com_sun_star_frame_theDesktop))))) {
					i_fileOpeningDispatcher = new UnoObjectPointer <XSynchronousDispatch> (i_underlyingUnoObject.getAddress <XDispatchProvider> ().queryDispatch (UnoDatumConverter.getUrlInURL ("file:///"), UnoSpecialFrameNamesConstantsGroup.c_new, GeneralConstantsConstantsGroup.c_unspecifiedInteger));
				}
				
				~UnoDesktop () {
				}
				
				public List <UnoObjectPointer <XComponent>> getChildObjects () {
					List <UnoObjectPointer <XComponent>> l_childObjects = ListsFactory.createList <UnoObjectPointer <XComponent>> ();
					UnoObjectPointer <XEnumeration> l_childObjectsIterator = new UnoObjectPointer <XEnumeration> (i_underlyingUnoObject.getAddress <XDesktop2> ().getComponents ().createEnumeration ());
					UnoObjectPointer <XComponent> l_childObject = null;
					while (l_childObjectsIterator.getAddress ().hasMoreElements ()) {
						try {
							l_childObject = new UnoObjectPointer <XComponent> ( (XComponent) UnoDatumConverter.getObject ((l_childObjectsIterator.getAddress ().nextElement ())));
							if (! (l_childObject.isEmpty ())) {
								l_childObjects.Add (l_childObject);
							}
						}
						catch (NoSuchElementException) {
							// Practically, never would happen
							break;
						}
						catch (WrappedTargetException) {
							// Practically, never would happen
							break;
						}
					}
					return l_childObjects;
				}
				
				public UnoObjectPointer <XComponent> getChildObject (String a_title) {
					UnoObjectPointer <XEnumeration> l_childObjectsIterator = new UnoObjectPointer <XEnumeration> (i_underlyingUnoObject.getAddress <XDesktop2> ().getComponents ().createEnumeration ());
					UnoObjectPointer <XComponent> l_childObject = null;
					while (l_childObjectsIterator.getAddress ().hasMoreElements ()) {
						try {
							l_childObject = new UnoObjectPointer <XComponent> ( (XComponent) UnoDatumConverter.getObject ((l_childObjectsIterator.getAddress ().nextElement ())));
							if (! (l_childObject.isEmpty ())) {
								if (l_childObject.getAddress <XTitle> ().getTitle ().Equals (a_title) ) {
									return l_childObject;
								}
							}
						}
						catch (NoSuchElementException) {
							// Practically, never would happen
							break;
						}
						catch (WrappedTargetException) {
							// Practically, never would happen
							break;
						}
					}
					return null;
				}
				
				/*
				virtual public void dispatchFinished (DispatchResultEvent a_dispatchResultEvent) {
					i_dispatchResultAndRelatedInformation.setResult (a_dispatchResultEvent);
				}
				*/
				
				virtual public UnoObjectPointer <XModel> loadUnoDocument (String a_url, String a_password, Boolean a_unoDocumentIsHidden) {
					return new UnoObjectPointer <XModel> (i_underlyingUnoObject.getAddress <XComponentLoader> ().loadComponentFromURL (RegularExpressionsConstantsGroup.c_windowsDirectoryDelimiterRegularExpression.Replace (a_url, GeneralConstantsConstantsGroup.c_linuxDirectoriesDelimiter.ToString ()), UnoSpecialFrameNamesConstantsGroup.c_new, FrameSearchFlag.CREATE, UnoPropertiesHandler.buildPropertiesArray (UnoDocumentOpeningEnumerablePropertyNamesSet.c_instance.getValues (), ListsFactory.createList <Any> (UnoDatumConverter.getAny (false), UnoDatumConverter.getAny (a_unoDocumentIsHidden), UnoDatumConverter.getAny (false), UnoDatumConverter.getAny (a_unoDocumentIsHidden), a_password != null ? a_password: ""))));
				}
				
				public UnoFrame getCurrentUnoFrame () {
					return new UnoFrame (i_remoteUnoObjectsContext, new UnoObjectPointer <XFrame> (i_underlyingUnoObject.getAddress <XDesktop2> ().getCurrentFrame ()));
				}
				 
				public UnoObjectPointer <XModel> getCurrentDocument () {
					return new UnoObjectPointer <XModel> (i_underlyingUnoObject.getAddress <XDesktop2> ().getCurrentComponent ());
				}
				
				public UnoObjectPointer <XModel> getDocument (String a_fileName) {
					UnoObjectPointer <XEnumeration> l_unoComponents = new UnoObjectPointer <XEnumeration> (i_underlyingUnoObject.getAddress <XDesktop2> ().getComponents ().createEnumeration ());
					while (l_unoComponents.getAddress ().hasMoreElements ()) {
						UnoObjectPointer <XStorable2> l_unoComponent = null;
						try {
							l_unoComponent = new UnoObjectPointer <XStorable2> (UnoDatumConverter.getObject (l_unoComponents.getAddress ().nextElement ()));
						}
						catch (NoSuchElementException) {
							// Practically, never would happen
							break;
						}
						catch (WrappedTargetException) {
							// Practically, never would happen
							break;
						}
						if (l_unoComponent.isEmpty ()) {
							continue;
						}
						try {
							//if (Paths.get (StringHandler.getFilePath (l_unoComponent.getAddress ().getLocation ())).getFileName ().toString ().equals (a_fileName)) {
							if (Path.GetFileName (l_unoComponent.getAddress ().getLocation ()).Equals (a_fileName)) {
								return new UnoObjectPointer <XModel> (l_unoComponent);
							}
						}
						// The possibility is that 'getLocation' returned null.
						catch (IllegalArgumentException) {
							continue;
						}
					}
					return null;
				}
				
				public UnoObjectPointer <XSynchronousDispatch> getFileOpeningDispatcher () {
					return i_fileOpeningDispatcher;
				}
			}
		}
	}
}

