namespace theBiasPlanet {
	namespace unoUtilities {
		namespace displayElements {
			using System;
			using System.Collections.Generic;
			using uno;
			using unoidl.com.sun.star.awt;
			using unoidl.com.sun.star.beans;
			using unoidl.com.sun.star.container;
			using unoidl.com.sun.star.frame;
			using unoidl.com.sun.star.lang;
			using theBiasPlanet.coreUtilities.collectionsHandling;
			using theBiasPlanet.coreUtilities.constantsGroups;
			using theBiasPlanet.coreUtilities.messagingHandling;
			using theBiasPlanet.unoUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets;
			using theBiasPlanet.unoUtilities.dispatchingHandling;
			using theBiasPlanet.unoUtilities.pointers;
			using theBiasPlanet.unoUtilities.propertiesHandling;
			using theBiasPlanet.unoUtilities.unoComponentBases;
			using theBiasPlanet.unoUtilities.unoDataHandling;
			using theBiasPlanet.unoUtilities.unoObjectsContexts;
			
			public class UnoFrame: UnoComponentBase, XDispatchResultListener, XStatusListener {
				protected RemoteUnoObjectsContext i_remoteUnoObjectsContext = null;
				protected UnoObjectPointer <XFrame> i_underlyingUnoObject;
				protected UnoObjectPointer <XWindow> i_containerWindow = null;
				protected UnoDispatchResultAndRelatedInformation i_dispatchResultAndRelatedInformation = null;
				
				public UnoFrame (RemoteUnoObjectsContext a_remoteUnoObjectsContext, UnoObjectPointer <XFrame> a_underlyingUnoObject) {
					i_remoteUnoObjectsContext = a_remoteUnoObjectsContext;
					i_underlyingUnoObject = a_underlyingUnoObject;
					i_containerWindow = new UnoObjectPointer <XWindow> (i_underlyingUnoObject.getAddress ().getContainerWindow ());
				}
				
				~UnoFrame () {
				}
				
				public void dispatchFinished (DispatchResultEvent a_dispatchResultEvent) {
					i_dispatchResultAndRelatedInformation.setResult (a_dispatchResultEvent);
				}
				
				public void statusChanged (FeatureStateEvent a_featureStateEvent) {
					i_dispatchResultAndRelatedInformation.addRelatedInformationPiece (a_featureStateEvent);
				}
				
				public void disposing (EventObject a_source) {
				}
				
				public RemoteUnoObjectsContext getRemoteUnoObjectsContext () {
					return i_remoteUnoObjectsContext;
				}
				
				public UnoObjectPointer <XFrame> getUnderlyingUnoObject () {
					return i_underlyingUnoObject;
				}
				
				public Rectangle getBoundary () {
					if (! (i_containerWindow.isEmpty ())) {
						unoidl.com.sun.star.awt.Rectangle l_boundary = i_containerWindow.getAddress ().getPosSize ();
						return new Rectangle (l_boundary.X, l_boundary.Y, l_boundary.Width, l_boundary.Height);
					}
					return null;
				}
				
				public UnoObjectPointer <XIndexAccess> getChildFramesIterator () {
					UnoObjectPointer <XIndexAccess> l_unoFramesIterator = new UnoObjectPointer <XIndexAccess> (i_underlyingUnoObject.getAddress <XFramesSupplier> ().getFrames ());
					return l_unoFramesIterator;
				}
				
				public List <UnoFrame> getChildFrames () {
					List <UnoFrame> l_childUnoFrames = null;
					UnoObjectPointer <XIndexAccess> l_unoFramesIterator = getChildFramesIterator ();
					int l_numberOfChildUnoFrames = l_unoFramesIterator.getAddress ().getCount ();
					if (l_numberOfChildUnoFrames > 0) {
						l_childUnoFrames = new List <UnoFrame> ();
						for (int l_unoFrameIndex = 0; l_unoFrameIndex < l_numberOfChildUnoFrames; l_unoFrameIndex ++) {
							try {
								l_childUnoFrames.Add (new UnoFrame (i_remoteUnoObjectsContext, new UnoObjectPointer <XFrame> ( (XFrame) UnoDatumConverter.getObject (l_unoFramesIterator.getAddress ().getByIndex (l_unoFrameIndex)))));
							}
							catch (Exception l_exception) {
								Publisher.logErrorInformation (l_exception);
							}
						}
					}
					return l_childUnoFrames;
				}
				
				public UnoObjectPointer <XNotifyingDispatch> getUnoDispatcher (unoidl.com.sun.star.util.URL a_urlInURL) {
					return new UnoObjectPointer <XNotifyingDispatch> (i_underlyingUnoObject.getAddress <XDispatchProvider> ().queryDispatch (a_urlInURL, UnoSpecialFrameNamesConstantsGroup.c_self, GeneralConstantsConstantsGroup.c_unspecifiedInteger));
				}
				
				public UnoDispatchResultAndRelatedInformation fulfill (UnoDispatchSlotsConstantsGroup.BaseUnoDispatchSlot a_unoDispatchSlot, List <Object> a_unoDispatchArgumentValues) {
					lock (this) {
						i_dispatchResultAndRelatedInformation = new UnoDispatchResultAndRelatedInformation ();
						PropertyValue [] l_unoDispatchArgumentPropertiesArray = null;
						if (a_unoDispatchSlot.c_unoDispatchArgumentPropertyNamesSet != null) {
							if (a_unoDispatchArgumentValues != null) {
								l_unoDispatchArgumentPropertiesArray = UnoPropertiesHandler.buildPropertiesArray (ListsFactory.createListExpandingItems <String> (UnoDispatchesCommonArgumentEnumerablePropertyNamesSet.c_instance.getValues (), a_unoDispatchSlot.c_unoDispatchArgumentPropertyNamesSet.getValues ()), ListsFactory.createListExpandingItems <Any> (true, a_unoDispatchArgumentValues));
							}
							else {
								l_unoDispatchArgumentPropertiesArray = UnoPropertiesHandler.buildPropertiesArray (UnoDispatchesCommonArgumentEnumerablePropertyNamesSet.c_instance.getValues (), ListsFactory.createList <Any> (true));
							}
						}
						else {
							if (a_unoDispatchArgumentValues != null) {
								l_unoDispatchArgumentPropertiesArray = UnoPropertiesHandler.buildPropertiesArray (ListsFactory.createListExpandingItems <String> (UnoDispatchesCommonArgumentEnumerablePropertyNamesSet.c_instance.getValues (), a_unoDispatchSlot.c_urlInURL.Path), ListsFactory.createListExpandingItems <Any> (true, a_unoDispatchArgumentValues [0]));
							}
							else {
								l_unoDispatchArgumentPropertiesArray = UnoPropertiesHandler.buildPropertiesArray (UnoDispatchesCommonArgumentEnumerablePropertyNamesSet.c_instance.getValues (), ListsFactory.createList <Any> (true));
							}
						}
						unoidl.com.sun.star.util.URL l_urlInURL = a_unoDispatchSlot.c_urlInURL;
						UnoObjectPointer <XNotifyingDispatch> l_unoDispatcher = getUnoDispatcher (l_urlInURL);
						if (l_unoDispatcher != null) {
							l_unoDispatcher.getAddress ().addStatusListener (this, l_urlInURL);
							l_unoDispatcher.getAddress ().dispatchWithNotification (l_urlInURL, l_unoDispatchArgumentPropertiesArray, this);
							l_unoDispatcher.getAddress ().removeStatusListener (this, l_urlInURL);
						}
						else {
							i_dispatchResultAndRelatedInformation = null;
						}
						return i_dispatchResultAndRelatedInformation;
					}
				}
			}
		}
	}
}

