namespace theBiasPlanet {
	namespace unoUtilities {
		namespace documentElements {
			using System;
			using unoidl.com.sun.star.beans;
			using unoidl.com.sun.star.container;
			using unoidl.com.sun.star.lang;
			using unoidl.com.sun.star.style;
			using unoidl.com.sun.star.text;
			using unoidl.com.sun.star.uno;
			using theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets;
			using theBiasPlanet.unoUtilities.documents;
			using theBiasPlanet.unoUtilities.pointers;
			using theBiasPlanet.unoUtilities.unoDataHandling;
			
			public class UnoTextPage {
				private UnoTextDocument i_unoTextDocument = null;
				private UnoObjectPointer <XTextViewCursor> i_unoPageCursor = null;
				
				public UnoTextPage (UnoTextDocument a_unoTextDocument, UnoObjectPointer <XTextViewCursor> a_unoPageCursor) {
					i_unoTextDocument = a_unoTextDocument;
					i_unoPageCursor = a_unoPageCursor;
				}
				
				public int getUnoPageIndex () {
					return (Int32) i_unoPageCursor.getAddress <XPageCursor> ().getPage ();
				}
				
				public Boolean moveToStartOfUnoPage () {
					return i_unoPageCursor.getAddress <XPageCursor> ().jumpToStartOfPage ();
				}
				
				public Boolean moveToEndOfUnoPage () {
					return i_unoPageCursor.getAddress <XPageCursor> ().jumpToEndOfPage ();
				}
				
				public Boolean moveToUnoPage (Int32 a_unoPageIndex) {
					return i_unoPageCursor.getAddress <XPageCursor> ().jumpToPage ( (Int16) (a_unoPageIndex + 1));
				}
				
				public Boolean moveToPreviousUnoPage () {
					return i_unoPageCursor.getAddress <XPageCursor> ().jumpToPreviousPage ();
				}
				
				public Boolean moveToNextUnoPage () {
					return i_unoPageCursor.getAddress <XPageCursor> ().jumpToNextPage ();
				}
				
				public String getUnoPageStyleName () {
					try {
						return (String) UnoDatumConverter.getObject (i_unoPageCursor.getAddress <XPropertySet> ().getPropertyValue (UnoTextPageCursorPropertyNamesSet.c_pageStyleName_string));
					}
					catch (UnknownPropertyException) {
						// Impossible
						return null;
					}
					catch (WrappedTargetException) {
						// Impossible
						return null;
					}
				}
				
				public UnoObjectPointer <XStyle> getUnoPageStyle () {
					try {
						return new UnoObjectPointer <XStyle> ( (XStyle) UnoDatumConverter.getObject (i_unoTextDocument.getUnoPageStyles ().getAddress ().getByName (getUnoPageStyleName ())));
					}
					catch (NoSuchElementException) {
						// Impossible
						return null;
					}
					catch (WrappedTargetException) {
						// Impossible
						return null;
					}
				}
			}
		}
	}
}

