namespace theBiasPlanet {
	namespace unoUtilities {
		namespace documents {
			using System;
			using unoidl.com.sun.star.container;
			using unoidl.com.sun.star.frame;
			using unoidl.com.sun.star.lang;
			using unoidl.com.sun.star.style;
			using unoidl.com.sun.star.text;
			using theBiasPlanet.coreUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets;
			using theBiasPlanet.unoUtilities.displayElements;
			using theBiasPlanet.unoUtilities.documentElements;
			using theBiasPlanet.unoUtilities.pointers;
			using theBiasPlanet.unoUtilities.unoDataHandling;
			using theBiasPlanet.unoUtilities.unoObjectsContexts;
			
			public class UnoTextDocument : UnoDocument {
				private UnoObjectPointer <XTextViewCursor> i_unoTextViewCursor= null;
				private UnoObjectPointer <XText> i_unoText = null;
				/*
				private XTextDocument i_unoTextDocumentInXTextDocument;
				private XTextViewCursorSupplier i_unoControllerInXTextViewCursorSupplier;
				*/
	
				
				public static UnoTextDocument createDocument (UnoDesktop a_unoDesktop, Boolean a_unoDocumentIsHidden) {
					return new UnoTextDocument (a_unoDesktop.getRemoteUnoObjectsContext (), a_unoDesktop.loadUnoDocument (UnoSpecialFileUrlsConstantsGroup.c_writerNewDocument, null, a_unoDocumentIsHidden));
				}
				
				public static UnoTextDocument openFile (UnoDesktop a_unoDesktop, String a_fileUrl, String a_password, Boolean a_unoDocumentIsHidden) {
					return new UnoTextDocument (a_unoDesktop.getRemoteUnoObjectsContext (), a_unoDesktop.loadUnoDocument (a_fileUrl, a_password, a_unoDocumentIsHidden));
				}
				
				public new static UnoTextDocument getCurrentDocument (UnoDesktop a_unoDesktop) {
					return new UnoTextDocument (a_unoDesktop.getRemoteUnoObjectsContext (), a_unoDesktop.getCurrentDocument ());
				}
				
				public UnoTextDocument (RemoteUnoObjectsContext a_remoteUnoObjectsContext, UnoObjectPointer <XModel> a_underlyingUnoObject): base (a_remoteUnoObjectsContext, a_underlyingUnoObject) {
					if (i_underlyingUnoObject.getAddress <XTextDocument> () == null) {
						throw new Exception (UnoMessagesConstantsGroup.c_isNotTextDocument);
					}
					i_unoTextViewCursor = new UnoObjectPointer <XTextViewCursor> (i_unoController.getAddress <XTextViewCursorSupplier> ().getViewCursor ());
					i_unoText = new UnoObjectPointer <XText> (i_underlyingUnoObject.getAddress <XTextDocument> ().getText ());
				}
	
				public UnoObjectPointer <XTextViewCursor> getUnoTextViewCursor () {
					return i_unoTextViewCursor;
				}
				
				public UnoObjectPointer <XTextCursor> getUnoTextCursor () {
					return new UnoObjectPointer <XTextCursor> (i_unoText.getAddress ().createTextCursor ());
				}
				
				public UnoObjectPointer <XNameContainer> getUnoPageStyles () {
					try {
						return new UnoObjectPointer <XNameContainer> ( (XNameContainer) UnoDatumConverter.getObject (i_underlyingUnoObject.getAddress <XStyleFamiliesSupplier> ().getStyleFamilies ().getByName (UnoStylesFamiliesConstantsGroup.c_unoPageStylesFamily.c_name)));
					}
					catch (NoSuchElementException) {
						// Impossible
						return null;
					}
					catch (WrappedTargetException) {
						// Impossible
						return null;
					}
				}
				
				// a_unoPageIndex: -1 -> the last page
				public UnoTextPage getUnoPage (Int32 a_unoPageIndex) {
					Boolean l_whetherUnoPageIsFound = false;
					if (a_unoPageIndex == GeneralConstantsConstantsGroup.c_unspecifiedInteger) {
						l_whetherUnoPageIsFound = i_unoTextViewCursor.getAddress <XPageCursor> ().jumpToLastPage ();
					}
					else {
						l_whetherUnoPageIsFound = i_unoTextViewCursor.getAddress <XPageCursor> ().jumpToPage ( (Int16) (a_unoPageIndex + 1));
					}
					if (l_whetherUnoPageIsFound) {
						return new UnoTextPage (this, i_unoTextViewCursor);
					}
					else {
						return null;
					}
				}
				
				public UnoObjectPointer <XNameAccess> getUnoSections () {
					return new UnoObjectPointer <XNameAccess> (i_underlyingUnoObject.getAddress <XTextSectionsSupplier> ().getTextSections ());
				}
				
				public UnoObjectPointer <XNameAccess> getUnoFrames () {
					return new UnoObjectPointer <XNameAccess> (i_underlyingUnoObject.getAddress <XTextFramesSupplier> ().getTextFrames ());
				}
				
				public UnoObjectPointer <XNameAccess> getUnoTables () {
					return new UnoObjectPointer <XNameAccess> (i_underlyingUnoObject.getAddress <XTextTablesSupplier> ().getTextTables ());
				}
				
				public Boolean insertText (String a_text) {
					getUnoTextViewCursor ().getAddress ().gotoEnd (false);
					i_unoText.getAddress ().insertString (i_unoTextViewCursor.getAddress (), a_text, false);
					return true;
				}
			}
		}
	}
}

