namespace theBiasPlanet {
	namespace unoUtilities {
		namespace pointers {
			using System;
			using System.Collections.Generic;
			using System.Text;
			using unoidl.com.sun.star.lang;
			using unoidl.com.sun.star.uno;
			using theBiasPlanet.coreUtilities.collections;
			using theBiasPlanet.coreUtilities.messagingHandling;
			using theBiasPlanet.unoUtilities.inspectionsHandling;
			using theBiasPlanet.unoUtilities.unoDataHandling;
			
			class UnoObjectPointersInformationDumpCondition {
				public static String c_unoObjectsInformationDumpFilePathString = null;
			}
			
			public class UnoObjectPointer <T> where T: class {
				private T i_primaryAddress = null;
				private NavigableLinkedHashMap <String, Object> i_unoInterfaceNameToAddressMap = new NavigableLinkedHashMap <String, Object> ();
				
				public static void setUnoObjectsInformationDumpFilePathString (String a_unoObjectsInformationDumpFilePathString) {
					UnoObjectPointersInformationDumpCondition.c_unoObjectsInformationDumpFilePathString = a_unoObjectsInformationDumpFilePathString;
				}
				
				public UnoObjectPointer () {
				}
				
				public UnoObjectPointer (T a_primaryAddress) {
					i_primaryAddress = a_primaryAddress;
					if (i_primaryAddress != null && UnoObjectPointersInformationDumpCondition.c_unoObjectsInformationDumpFilePathString != null) {
						try {
							Publisher.appendToFile (UnoObjectPointersInformationDumpCondition.c_unoObjectsInformationDumpFilePathString, String.Format ("### {0:s} -> {1:s}", this.ToString (), String.Join (", ", getUnoTypeNames ())));
							StringBuilder l_propertyNameValuePairsStringBuilder = new StringBuilder ();
							NavigableLinkedHashMap <String, Object> l_propertyNameToValueMap = getPropertyNameToValueMap ();
							Boolean l_is1stItem = true;
							foreach (KeyValuePair <String, Object> l_propertyNameToValueMapEntry in l_propertyNameToValueMap) {
								if (l_is1stItem) {
									l_is1stItem = false;
								}
								else {
									l_propertyNameValuePairsStringBuilder.Append (", ");
								}
								l_propertyNameValuePairsStringBuilder.Append (l_propertyNameToValueMapEntry.Key);
								l_propertyNameValuePairsStringBuilder.Append (": ");
								l_propertyNameValuePairsStringBuilder.Append (UnoDatumConverter.getObject (l_propertyNameToValueMapEntry.Value));
							}
							Publisher.appendToFile (UnoObjectPointersInformationDumpCondition.c_unoObjectsInformationDumpFilePathString, String.Format ("### {0:s} -> {1:s}", this.ToString (), l_propertyNameValuePairsStringBuilder.ToString ()));
						}
						catch (UnoInterfaceNotImplementedException l_exception) {
							Publisher.appendToFile (UnoObjectPointersInformationDumpCondition.c_unoObjectsInformationDumpFilePathString, String.Format ("### {0:s} -> {1:s}", this.ToString (), l_exception.ToString ()));
						}
						catch (WrappedTargetException l_exception) {
							Publisher.appendToFile (UnoObjectPointersInformationDumpCondition.c_unoObjectsInformationDumpFilePathString, String.Format ("### {0:s} -> {1:s}", this.ToString (), l_exception.ToString ()));
						}
					}
				}
				
				public UnoObjectPointer (Object a_sourceAddress): this ( (T) a_sourceAddress) {
				}
				
				/*
				public UnoObjectPointer (UnoObjectPointer <Object> a_sourcePointer): this (a_sourcePointer.getAddress <T> ()) {
				}
				This really should be a constructor, but any generic constructor is foolishly not supported in C#, so, use the succeeding factory.
				*/
				public static UnoObjectPointer <T> getUnoObjectPointer <U> (UnoObjectPointer <U> a_sourcePointer) where U: class {
					UnoObjectPointer <T> l_unoObjectPointer = new UnoObjectPointer <T> (a_sourcePointer.getAddress <T> ());
					l_unoObjectPointer.i_unoInterfaceNameToAddressMap = a_sourcePointer.i_unoInterfaceNameToAddressMap;
					return l_unoObjectPointer;
				}
				
				~UnoObjectPointer () {
					clear ();
				}
				
				public List <String> getUnoTypeNames () {
					return UnoComponentInspector.getUnoTypeNames (i_primaryAddress);
				}
				
				public NavigableLinkedHashMap <String, Object> getPropertyNameToValueMap () {
					return UnoComponentInspector.getPropertyNameToValueMap (i_primaryAddress);
				}
				
				public bool isEmpty () {
					return i_primaryAddress == null;
				}
				
				public void setPrimaryAddress (T a_primaryAddress) {
					clear ();
					i_primaryAddress = a_primaryAddress;
				}
				
				public void clear () {
					if (i_primaryAddress != null) {
						i_primaryAddress = null;
						i_unoInterfaceNameToAddressMap = new NavigableLinkedHashMap <String, Object> ();
					}
				}
				
				public T getAddress () {
					return i_primaryAddress;
				}
				
				public U getAddress <U> () where U: class {
					U l_address = null;
					String l_unoInterfaceName = typeof (U).FullName;
					try {
						l_address = (U) i_unoInterfaceNameToAddressMap [l_unoInterfaceName];
					}
					catch (KeyNotFoundException) {
						try {
							l_address = (U) (Object) i_primaryAddress;
							if (l_address != null) {
								i_unoInterfaceNameToAddressMap.Add (l_unoInterfaceName, l_address);
							}
							else {
							}
						}
						catch (InvalidCastException) {
						}
					}
					return l_address;
				}
			}
		}
	}
}

