namespace theBiasPlanet {
	namespace unoUtilities {
		namespace unoObjectsContexts {
			using System;
			using System.Collections.Generic;
			using uno;
			using unoidl.com.sun.star.container;
			using unoidl.com.sun.star.lang;
			using unoidl.com.sun.star.uno;
			using theBiasPlanet.coreUtilities.collectionsHandling;
			using theBiasPlanet.coreUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.constantsGroups;
			using theBiasPlanet.unoUtilities.constantsGroups.propertyNamesSets;
			using theBiasPlanet.unoUtilities.unoDataHandling;
			
			public class LocalUnoObjectsContext: UnoObjectsContext {
				private XComponentContext i_underlyingUnoObject = null;
				private XMultiComponentFactory i_unoGlobalServicesManager = null;
				
				public LocalUnoObjectsContext (XComponentContext a_underlyingUnoObject, String a_unoConnectionIdentification): base (a_unoConnectionIdentification) {
					i_underlyingUnoObject = a_underlyingUnoObject;
					i_unoGlobalServicesManager = i_underlyingUnoObject.getServiceManager ();
				}
				
				~LocalUnoObjectsContext () {
				}
				
				override public Any getValueByName (String a_propertyName) {
					return i_underlyingUnoObject.getValueByName (a_propertyName);
				}
				
				override public void addExtraGlobalProperty (String a_propertyName, Any a_propertyValue) {
					( (XNameContainer) i_underlyingUnoObject).insertByName (a_propertyName, a_propertyValue);
				}
				
				override public void removeExtraGlobalProperty (String a_propertyName) {
					( (XNameContainer) i_underlyingUnoObject).removeByName (a_propertyName);
				}
				
				override public XMultiComponentFactory getServiceManager () {
					return i_unoGlobalServicesManager;
				}
				
				public T getUnoServiceInstance <T> (String a_unoServiceName, List <Any> a_unoServiceInstantiationArguments) where T: class {
					if (a_unoServiceInstantiationArguments == null) {
						return (T) (getServiceManager ().createInstanceWithContext (a_unoServiceName, this));
					}
					else {
						return (T) (getServiceManager ().createInstanceWithArgumentsAndContext (a_unoServiceName, ArraysFactory.createArray <Any> (a_unoServiceInstantiationArguments), this));
					}
				}
				
				private Boolean addGlobalUnoService (XSingleComponentFactory a_globalUnoServiceInstancesFactory) {
					( (XSet) i_unoGlobalServicesManager).insert (UnoDatumConverter.getAny (a_globalUnoServiceInstancesFactory));
					return true;
				}
			}
		}
	}
}

