from typing import Any
from typing import Generic
from typing import List
from typing import Type
from typing import TypeVar
from collections import OrderedDict
from com.sun.star.lang import WrappedTargetException
from com.sun.star.uno import XInterface
from theBiasPlanet.coreUtilities.messagingHandling.Publisher import Publisher
from theBiasPlanet.unoUtilities.inspectionsHandling.UnoComponentInspector import UnoComponentInspector
from theBiasPlanet.unoUtilities.inspectionsHandling.UnoInterfaceNotImplementedException import UnoInterfaceNotImplementedException

T = TypeVar ("T", bound=XInterface)
U = TypeVar ("U", bound=XInterface)

class UnoObjectPointer (Generic [T]):
	c_unoObjectsInformationDumpFilePathString: str = None
	
	@staticmethod
	def setUnoObjectsInformationDumpFilePathString (a_unoObjectsInformationDumpFilePathString: str) -> None:
		UnoObjectPointer.c_unoObjectsInformationDumpFilePathString = a_unoObjectsInformationDumpFilePathString
	
	def __init__ (a_this: "UnoObjectPointer [T]", a_type0: Type [T], a_primaryAddress: XInterface) -> None:
		a_this.i_primaryAddress: XInterface = None
		
		a_this.i_primaryAddress = a_primaryAddress
		if a_primaryAddress is not None and UnoObjectPointer.c_unoObjectsInformationDumpFilePathString is not None:
			try:
				Publisher.appendToFile (UnoObjectPointer.c_unoObjectsInformationDumpFilePathString, "### {0:s} -> {1:s}".format (str (a_this.i_primaryAddress), ", ".join (a_this.getUnoTypeNames ())))
				l_propertyNameValuePairsStringBuilder: List [str] = []
				l_propertyNameToValueMap: "OrderedDict [str, object]" = a_this.getPropertyNameToValueMap ()
				l_is1stItem: bool = True
				for l_propertyNameToValueMapEntryKey, l_propertyNameToValueMapEntryValue in l_propertyNameToValueMap.items ():
					if l_is1stItem:
						l_is1stItem = False
					else:
						l_propertyNameValuePairsStringBuilder.append (", ")
					l_propertyNameValuePairsStringBuilder.append (l_propertyNameToValueMapEntryKey)
					l_propertyNameValuePairsStringBuilder.append (": ")
					l_propertyNameValuePairsStringBuilder.append (str (l_propertyNameToValueMapEntryValue))
				Publisher.appendToFile (UnoObjectPointer.c_unoObjectsInformationDumpFilePathString, "### {0:s} -> {1:s}".format (str (a_this.i_primaryAddress), "".join (l_propertyNameValuePairsStringBuilder)))
			except (UnoInterfaceNotImplementedException, WrappedTargetException) as l_exception:
				Publisher.appendToFile (UnoObjectPointer.c_unoObjectsInformationDumpFilePathString, "### {0:s} -> {1:s}".format (str (a_this.i_primaryAddress), str (l_exception)))
	
	@staticmethod
	def getUnoObjectPointer (a_type0: Type [T], a_sourceClass: Type [U], a_sourcePointer: "UnoObjectPointer [U]") -> "UnoObjectPointer [T]":
		l_unoObjectPointer: "UnoObjectPointer [T]" = UnoObjectPointer (a_type0, a_sourcePointer.getAddress ())
		return l_unoObjectPointer
	
	def __del__ (a_this: "UnoObjectPointer [T]") -> None:
		a_this.clear ()
	
	def getUnoTypeNames (a_this: "UnoObjectPointer [T]") -> List [str]:
		return UnoComponentInspector.getUnoTypeNames (a_this.i_primaryAddress)
	
	def getPropertyNameToValueMap (a_this: "UnoObjectPointer [T]") -> "OrderedDict [str, object]":
		return UnoComponentInspector.getPropertyNameToValueMap (a_this.i_primaryAddress)
	
	def isEmpty (a_this: "UnoObjectPointer [T]") -> bool:
		return a_this.i_primaryAddress is None
	
	def setPrimaryAddress (a_this: "UnoObjectPointer [T]", a_primaryAddress: XInterface) -> None:
		a_this.clear ()
		a_this.i_primaryAddress = a_primaryAddress
	
	def clear (a_this: "UnoObjectPointer [T]") -> None:
		if a_this.i_primaryAddress is not None:
			a_this.i_primaryAddress = None
	
	def getAddress (a_this: "UnoObjectPointer [T]") -> Any:
		return a_this.i_primaryAddress

