from typing import List
from typing import Optional
from typing import Type
from typing import TypeVar
from abc import ABCMeta
from abc import abstractmethod
from com.sun.star.security import XCertificate
from com.sun.star.uno import XComponentContext
from com.sun.star.uno import XInterface
from theBiasPlanet.unoUtilities.pointers.UnoObjectPointer import UnoObjectPointer
from theBiasPlanet.unoUtilities.unoObjectsContexts.UnoObjectsContext import UnoObjectsContext

T = TypeVar ("T", bound="XInterface")

class RemoteUnoObjectsContextInterface (UnoObjectsContext, metaclass=ABCMeta):
	def __init__ (a_this: "RemoteUnoObjectsContextInterface", a_underlyingUnoObject: "UnoObjectPointer [XComponentContext]", a_unoConnectionIdentification: str) -> None:
		
		super ().__init__ (a_unoConnectionIdentification)
	
	def __del__ (a_this: "RemoteUnoObjectsContextInterface") -> None:
		None
	
	@abstractmethod
	def getUnderlyingUnoObject (a_this: "RemoteUnoObjectsContextInterface") -> "UnoObjectPointer [XComponentContext]":
		return None
	
	@abstractmethod
	def getUnoServiceInstance (a_this: "RemoteUnoObjectsContextInterface", a_type0: Type [T], a_unoServiceName: str, a_unoServiceInstantiationArguments: Optional [List [object]]) -> "UnoObjectPointer [T]":
		return None
	
	@abstractmethod
	def setUpForOfficeInstance (a_this: "RemoteUnoObjectsContextInterface") -> bool:
		return False
	
	@abstractmethod
	def officeInstanceSingletonIsSet (a_this: "RemoteUnoObjectsContextInterface") -> bool:
		return False
	
	@abstractmethod
	def incrementCriticalSessionCount (a_this: "RemoteUnoObjectsContextInterface", a_connectionIdentification: str) -> bool:
		return False
	
	@abstractmethod
	def decrementCriticalSessionCount (a_this: "RemoteUnoObjectsContextInterface", a_connectionIdentification: str) -> None:
		None
	
	@abstractmethod
	def getCriticalSessionCount (a_this: "RemoteUnoObjectsContextInterface") -> int:
		return -1
	
	@abstractmethod
	def serverIsPlannedToBeTerminated (a_this: "RemoteUnoObjectsContextInterface") -> bool:
		return False
	
	@abstractmethod
	def selectCertificateFromCertificates (a_this: "RemoteUnoObjectsContextInterface", a_certificates: List ["UnoObjectPointer [XCertificate]"], a_certificateIssuerName: str, a_certificateSerialNumber: List [int]) -> "UnoObjectPointer [XCertificate]":
		return None
	
	@abstractmethod
	def getGnupgCertificate (a_this: "RemoteUnoObjectsContextInterface", a_certificateIssuerName: str) -> "UnoObjectPointer [XCertificate]":
		return None
	
	@abstractmethod
	def getNetworkSecurityServicesCertificate (a_this: "RemoteUnoObjectsContextInterface", a_certificateIssuerName: str, a_certificateSerialNumber: List [int]) -> "UnoObjectPointer [XCertificate]":
		return None

